=begin
#Tradenity API

#Tradenity eCommerce Rest API

Contact: support@tradenity.com
Generated by: https://github.com/tradenity

=end

require 'uri'

module Tradenity
  class Country

  
    def id=(id)
      @id = id
    end

    def id
      if instance_variable_defined?('@id') && @id != nil
        @id
      elsif __meta && __meta.href != nil
        @id = __meta.href.split('/')[-1]
        @id
      else
        nil
      end
    end

    attr_accessor :__meta

    attr_accessor :created_at

    attr_accessor :updated_at

    attr_accessor :name

    attr_accessor :iso2

    attr_accessor :iso3

    attr_accessor :iso3166

    attr_accessor :country_code

    attr_accessor :sub_region

    attr_accessor :region

    attr_accessor :status

    attr_accessor :states

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      { 
        :'id' => :'id',
        :'__meta' => :'__meta',
        :'created_at' => :'createdAt',
        :'updated_at' => :'updatedAt',
        :'name' => :'name',
        :'iso2' => :'iso2',
        :'iso3' => :'iso3',
        :'iso3166' => :'iso3166',
        :'country_code' => :'countryCode',
        :'sub_region' => :'subRegion',
        :'region' => :'region',
        :'status' => :'status',
        :'states' => :'states'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      { 
        :'id' => :'String', 
        :'__meta' => :'InstanceMeta',
        :'created_at' => :'DateTime',
        :'updated_at' => :'DateTime',
        :'name' => :'String',
        :'iso2' => :'String',
        :'iso3' => :'String',
        :'iso3166' => :'String',
        :'country_code' => :'String',
        :'sub_region' => :'String',
        :'region' => :'String',
        :'status' => :'String',
        :'states' => :'Array<State>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }
      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'__meta')
        self.__meta = attributes[:'__meta']
      end

      if attributes.has_key?(:'createdAt')
        self.created_at = attributes[:'createdAt']
      end

      if attributes.has_key?(:'created_at')
        self.created_at = attributes[:'created_at']
      end

      if attributes.has_key?(:'updatedAt')
        self.updated_at = attributes[:'updatedAt']
      end

      if attributes.has_key?(:'updated_at')
        self.updated_at = attributes[:'updated_at']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'iso2')
        self.iso2 = attributes[:'iso2']
      end

      if attributes.has_key?(:'iso3')
        self.iso3 = attributes[:'iso3']
      end

      if attributes.has_key?(:'iso3166')
        self.iso3166 = attributes[:'iso3166']
      end

      if attributes.has_key?(:'countryCode')
        self.country_code = attributes[:'countryCode']
      end

      if attributes.has_key?(:'country_code')
        self.country_code = attributes[:'country_code']
      end

      if attributes.has_key?(:'subRegion')
        self.sub_region = attributes[:'subRegion']
      end

      if attributes.has_key?(:'sub_region')
        self.sub_region = attributes[:'sub_region']
      end

      if attributes.has_key?(:'region')
        self.region = attributes[:'region']
      end

      if attributes.has_key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.has_key?(:'states')
        if (value = attributes[:'states']).is_a?(Array)
          self.states = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @iso2.nil?
        invalid_properties.push('invalid value for "iso2", iso2 cannot be nil.')
      end

      if @iso3.nil?
        invalid_properties.push('invalid value for "iso3", iso3 cannot be nil.')
      end

      if @iso3166.nil?
        invalid_properties.push('invalid value for "iso3166", iso3166 cannot be nil.')
      end

      if @country_code.nil?
        invalid_properties.push('invalid value for "country_code", country_code cannot be nil.')
      end

      if @sub_region.nil?
        invalid_properties.push('invalid value for "sub_region", sub_region cannot be nil.')
      end

      if @region.nil?
        invalid_properties.push('invalid value for "region", region cannot be nil.')
      end

      if @status.nil?
        invalid_properties.push('invalid value for "status", status cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @name.nil?
      return false if @iso2.nil?
      return false if @iso3.nil?
      return false if @iso3166.nil?
      return false if @country_code.nil?
      return false if @sub_region.nil?
      return false if @region.nil?
      return false if @status.nil?
      status_validator = EnumAttributeValidator.new('String', ['enabled', 'disabled'])
      return false unless status_validator.valid?(@status)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      validator = EnumAttributeValidator.new('String', ['enabled', 'disabled'])
      unless validator.valid?(status)
        fail ArgumentError, 'invalid value for "status", must be one of #{validator.allowable_values}.'
      end
      @status = status
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          __meta == o.__meta &&
          created_at == o.created_at &&
          updated_at == o.updated_at &&
          name == o.name &&
          iso2 == o.iso2 &&
          iso3 == o.iso3 &&
          iso3166 == o.iso3166 &&
          country_code == o.country_code &&
          sub_region == o.sub_region &&
          region == o.region &&
          status == o.status &&
          states == o.states
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [__meta, created_at, updated_at, name, iso2, iso3, iso3166, country_code, sub_region, region, status, states].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Tradenity.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end


    def self.api_client
      ApiClient.default
    end

    # Create Country
    # Create a new Country
    def create
      data = self.class.create_country(self)
      self.id = data.id
      data
    end

    # Update Country
    # Update attributes of Country
    # @return [Country]
    def update
      self.class.update_country_by_id(self.id, self)
    end

    # Delete Country
    # Delete this instance of Country.
    # @return [nil]
    def delete
      self.class.delete_country_by_id(self.id)
    end

    class << self

      # List Countrys
      # Return a list of Countrys
      # @param [Hash] opts the optional parameters
      # @return [Page<Country>]
      def find_all
        list_all_countries
      end

      # Find List of Country
      # Return multiple instances of Country by its attributes.
      # @param [Hash] opts the search parameters
      # @return [Page<Collection>]
      def find_all_by(opts = {})
        list_all_countries(opts)
      end

      # Find Country by its parameters
      # Return single instance of Collection by its attributes.
      # @param [Hash] opts search parameters
      # @return [Country]
      def find_one_by(opts = {})
        list_all_countries(opts)[0]
      end

      # Find Country
      # Return single instance of Country by its ID.
      # @param id ID of Country to return
      # @return [Country]
      def find_by_id(id)
        get_country_by_id(id)
      end

      # Delete Country
      # Delete an instance of Country by its ID.
      # @param id ID of Country to delete.
      # @return [nil]
      def delete_by_id(id)
        delete_country_by_id(id)
      end

      # Create Country
      # Create a new Country
      # @param country Attributes of country to create
      # @param [Hash] opts the optional parameters
      # @return [Country]
      def create_country(country, opts = {})
        data, _status_code, _headers = create_country_with_http_info(country, opts)
        data
      end

      # Create Country
      # Create a new Country
      # @param country Attributes of country to create
      # @param [Hash] opts the optional parameters
      # @return [Array<(Country, Fixnum, Hash)>] Country data, response status code and response headers
      def create_country_with_http_info(country, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Country.create_country ...'
        end
        # verify the required parameter 'country' is set
        if api_client.config.client_side_validation && country.nil?
          fail ArgumentError, "Missing the required parameter 'country' when calling Country.create_country"
        end
        # resource path
        local_var_path = '/countries'

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(country)
        auth_names = []
        data, status_code, headers = api_client.call_api(:POST, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Country')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Country#create_country\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Delete Country
      # Delete an instance of Country by its ID.
      # @param country_id ID of country to delete.
      # @param [Hash] opts the optional parameters
      # @return [nil]
      def delete_country_by_id(country_id, opts = {})
        delete_country_by_id_with_http_info(country_id, opts)
        nil
      end

      # Delete Country
      # Delete an instance of Country by its ID.
      # @param country_id ID of country to delete.
      # @param [Hash] opts the optional parameters
      # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
      def delete_country_by_id_with_http_info(country_id, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Country.delete_country_by_id ...'
        end
        # verify the required parameter 'country_id' is set
        if api_client.config.client_side_validation && country_id.nil?
          fail ArgumentError, "Missing the required parameter 'country_id' when calling Country.delete_country_by_id"
        end
        # resource path
        local_var_path = '/countries/{countryId}'.sub('{' + 'countryId' + '}', country_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:DELETE, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names)
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Country#delete_country_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Find Country
      # Return single instance of Country by its ID.
      # @param country_id ID of country to return
      # @param [Hash] opts the optional parameters
      # @return [Country]
      def get_country_by_id(country_id, opts = {})
        data, _status_code, _headers = get_country_by_id_with_http_info(country_id, opts)
        data
      end

      # Find Country
      # Return single instance of Country by its ID.
      # @param country_id ID of country to return
      # @param [Hash] opts the optional parameters
      # @return [Array<(Country, Fixnum, Hash)>] Country data, response status code and response headers
      def get_country_by_id_with_http_info(country_id, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Country.get_country_by_id ...'
        end
        # verify the required parameter 'country_id' is set
        if api_client.config.client_side_validation && country_id.nil?
          fail ArgumentError, "Missing the required parameter 'country_id' when calling Country.get_country_by_id"
        end
        # resource path
        local_var_path = '/countries/{countryId}'.sub('{' + 'countryId' + '}', country_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:GET, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Country')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Country#get_country_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # List Countries
      # Return a list of Countries
      # @param [Hash] opts the optional parameters
      # @option opts [Integer] :page page number
      # @option opts [Integer] :size page size
      # @option opts [String] :sort page order
      # @return [Page<Country>]
      def list_all_countries(opts = {})
        data, _status_code, _headers = list_all_countries_with_http_info(opts)
        data
      end

      # List Countries
      # Return a list of Countries
      # @param [Hash] opts the optional parameters
      # @option opts [Integer] :page page number
      # @option opts [Integer] :size page size
      # @option opts [String] :sort page order
      # @return [Array<(Page<Country>, Fixnum, Hash)>] Page<Country> data, response status code and response headers
      def list_all_countries_with_http_info(opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Country.list_all_countries ...'
        end
        # resource path
        local_var_path = '/countries'

        # query parameters
        query_params = opts
        # query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
        # query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?
        # query_params[:'sort'] = opts[:'sort'] if !opts[:'sort'].nil?

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:GET, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Page<Country>')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Country#list_all_countries\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Replace Country
      # Replace all attributes of Country
      # @param country_id ID of country to replace
      # @param country Attributes of country to replace
      # @param [Hash] opts the optional parameters
      # @return [Country]
      def replace_country_by_id(country_id, country, opts = {})
        data, _status_code, _headers = replace_country_by_id_with_http_info(country_id, country, opts)
        data
      end

      # Replace Country
      # Replace all attributes of Country
      # @param country_id ID of country to replace
      # @param country Attributes of country to replace
      # @param [Hash] opts the optional parameters
      # @return [Array<(Country, Fixnum, Hash)>] Country data, response status code and response headers
      def replace_country_by_id_with_http_info(country_id, country, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Country.replace_country_by_id ...'
        end
        # verify the required parameter 'country_id' is set
        if api_client.config.client_side_validation && country_id.nil?
          fail ArgumentError, "Missing the required parameter 'country_id' when calling Country.replace_country_by_id"
        end
        # verify the required parameter 'country' is set
        if api_client.config.client_side_validation && country.nil?
          fail ArgumentError, "Missing the required parameter 'country' when calling Country.replace_country_by_id"
        end
        # resource path
        local_var_path = '/countries/{countryId}'.sub('{' + 'countryId' + '}', country_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(country)
        auth_names = []
        data, status_code, headers = api_client.call_api(:PUT, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Country')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Country#replace_country_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Update Country
      # Update attributes of Country
      # @param country_id ID of country to update.
      # @param country Attributes of country to update.
      # @param [Hash] opts the optional parameters
      # @return [Country]
      def update_country_by_id(country_id, country, opts = {})
        data, _status_code, _headers = update_country_by_id_with_http_info(country_id, country, opts)
        data
      end

      # Update Country
      # Update attributes of Country
      # @param country_id ID of country to update.
      # @param country Attributes of country to update.
      # @param [Hash] opts the optional parameters
      # @return [Array<(Country, Fixnum, Hash)>] Country data, response status code and response headers
      def update_country_by_id_with_http_info(country_id, country, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Country.update_country_by_id ...'
        end
        # verify the required parameter 'country_id' is set
        if api_client.config.client_side_validation && country_id.nil?
          fail ArgumentError, "Missing the required parameter 'country_id' when calling Country.update_country_by_id"
        end
        # verify the required parameter 'country' is set
        if api_client.config.client_side_validation && country.nil?
          fail ArgumentError, "Missing the required parameter 'country' when calling Country.update_country_by_id"
        end
        # resource path
        local_var_path = '/countries/{countryId}'.sub('{' + 'countryId' + '}', country_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(country)
        auth_names = []
        data, status_code, headers = api_client.call_api(:PATCH, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Country')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Country#update_country_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
    end
  end
end
