=begin
#Tradenity API

#Tradenity eCommerce Rest API

Contact: support@tradenity.com
Generated by: https://github.com/tradenity

=end

require 'uri'

module Tradenity
  class CreditCardPayment

  
    def id=(id)
      @id = id
    end

    def id
      if instance_variable_defined?('@id') && @id != nil
        @id
      elsif __meta && __meta.href != nil
        @id = __meta.href.split('/')[-1]
        @id
      else
        nil
      end
    end

    attr_accessor :__meta

    attr_accessor :created_at

    attr_accessor :updated_at

    attr_accessor :amount

    attr_accessor :order

    attr_accessor :payment_source

    attr_accessor :currency

    attr_accessor :status

    attr_accessor :gateway

    attr_accessor :payment_mode

    attr_accessor :gateway_operation_id

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      { 
        :'id' => :'id',
        :'__meta' => :'__meta',
        :'created_at' => :'createdAt',
        :'updated_at' => :'updatedAt',
        :'amount' => :'amount',
        :'order' => :'order',
        :'payment_source' => :'paymentSource',
        :'currency' => :'currency',
        :'status' => :'status',
        :'gateway' => :'gateway',
        :'payment_mode' => :'paymentMode',
        :'gateway_operation_id' => :'gatewayOperationId'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      { 
        :'id' => :'String', 
        :'__meta' => :'InstanceMeta',
        :'created_at' => :'DateTime',
        :'updated_at' => :'DateTime',
        :'amount' => :'Integer',
        :'order' => :'Order',
        :'payment_source' => :'PaymentSource',
        :'currency' => :'Currency',
        :'status' => :'String',
        :'gateway' => :'Gateway',
        :'payment_mode' => :'String',
        :'gateway_operation_id' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }
      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'__meta')
        self.__meta = attributes[:'__meta']
      end

      if attributes.has_key?(:'createdAt')
        self.created_at = attributes[:'createdAt']
      end

      if attributes.has_key?(:'created_at')
        self.created_at = attributes[:'created_at']
      end

      if attributes.has_key?(:'updatedAt')
        self.updated_at = attributes[:'updatedAt']
      end

      if attributes.has_key?(:'updated_at')
        self.updated_at = attributes[:'updated_at']
      end

      if attributes.has_key?(:'amount')
        self.amount = attributes[:'amount']
      end

      if attributes.has_key?(:'order')
        self.order = attributes[:'order']
      end

      if attributes.has_key?(:'paymentSource')
        self.payment_source = attributes[:'paymentSource']
      end

      if attributes.has_key?(:'payment_source')
        self.payment_source = attributes[:'payment_source']
      end

      if attributes.has_key?(:'currency')
        self.currency = attributes[:'currency']
      end

      if attributes.has_key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.has_key?(:'gateway')
        self.gateway = attributes[:'gateway']
      end

      if attributes.has_key?(:'paymentMode')
        self.payment_mode = attributes[:'paymentMode']
      end

      if attributes.has_key?(:'payment_mode')
        self.payment_mode = attributes[:'payment_mode']
      end

      if attributes.has_key?(:'gatewayOperationId')
        self.gateway_operation_id = attributes[:'gatewayOperationId']
      end

      if attributes.has_key?(:'gateway_operation_id')
        self.gateway_operation_id = attributes[:'gateway_operation_id']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @amount.nil?
        invalid_properties.push('invalid value for "amount", amount cannot be nil.')
      end

      if @order.nil?
        invalid_properties.push('invalid value for "order", order cannot be nil.')
      end

      if @payment_source.nil?
        invalid_properties.push('invalid value for "payment_source", payment_source cannot be nil.')
      end

      if @currency.nil?
        invalid_properties.push('invalid value for "currency", currency cannot be nil.')
      end

      if @status.nil?
        invalid_properties.push('invalid value for "status", status cannot be nil.')
      end

      if @gateway.nil?
        invalid_properties.push('invalid value for "gateway", gateway cannot be nil.')
      end

      if @gateway_operation_id.nil?
        invalid_properties.push('invalid value for "gateway_operation_id", gateway_operation_id cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @amount.nil?
      return false if @order.nil?
      return false if @payment_source.nil?
      return false if @currency.nil?
      return false if @status.nil?
      status_validator = EnumAttributeValidator.new('String', ['pending', 'awaitingRetry', 'successful', 'failed'])
      return false unless status_validator.valid?(@status)
      return false if @gateway.nil?
      payment_mode_validator = EnumAttributeValidator.new('String', ['authorize', 'capture'])
      return false unless payment_mode_validator.valid?(@payment_mode)
      return false if @gateway_operation_id.nil?
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      validator = EnumAttributeValidator.new('String', ['pending', 'awaitingRetry', 'successful', 'failed'])
      unless validator.valid?(status)
        fail ArgumentError, 'invalid value for "status", must be one of #{validator.allowable_values}.'
      end
      @status = status
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] payment_mode Object to be assigned
    def payment_mode=(payment_mode)
      validator = EnumAttributeValidator.new('String', ['authorize', 'capture'])
      unless validator.valid?(payment_mode)
        fail ArgumentError, 'invalid value for "payment_mode", must be one of #{validator.allowable_values}.'
      end
      @payment_mode = payment_mode
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          __meta == o.__meta &&
          created_at == o.created_at &&
          updated_at == o.updated_at &&
          amount == o.amount &&
          order == o.order &&
          payment_source == o.payment_source &&
          currency == o.currency &&
          status == o.status &&
          gateway == o.gateway &&
          payment_mode == o.payment_mode &&
          gateway_operation_id == o.gateway_operation_id
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [__meta, created_at, updated_at, amount, order, payment_source, currency, status, gateway, payment_mode, gateway_operation_id].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Tradenity.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end


    def self.api_client
      ApiClient.default
    end

    # Create CreditCardPayment
    # Create a new CreditCardPayment
    def create
      data = self.class.create_credit_card_payment(self)
      self.id = data.id
      data
    end

    # Update CreditCardPayment
    # Update attributes of CreditCardPayment
    # @return [CreditCardPayment]
    def update
      self.class.update_credit_card_payment_by_id(self.id, self)
    end

    # Delete CreditCardPayment
    # Delete this instance of CreditCardPayment.
    # @return [nil]
    def delete
      self.class.delete_credit_card_payment_by_id(self.id)
    end

    class << self

      # List CreditCardPayments
      # Return a list of CreditCardPayments
      # @param [Hash] opts the optional parameters
      # @return [Page<CreditCardPayment>]
      def find_all
        list_all_credit_card_payments
      end

      # Find List of CreditCardPayment
      # Return multiple instances of CreditCardPayment by its attributes.
      # @param [Hash] opts the search parameters
      # @return [Page<Collection>]
      def find_all_by(opts = {})
        list_all_credit_card_payments(opts)
      end

      # Find CreditCardPayment by its parameters
      # Return single instance of Collection by its attributes.
      # @param [Hash] opts search parameters
      # @return [CreditCardPayment]
      def find_one_by(opts = {})
        list_all_credit_card_payments(opts)[0]
      end

      # Find CreditCardPayment
      # Return single instance of CreditCardPayment by its ID.
      # @param id ID of CreditCardPayment to return
      # @return [CreditCardPayment]
      def find_by_id(id)
        get_credit_card_payment_by_id(id)
      end

      # Delete CreditCardPayment
      # Delete an instance of CreditCardPayment by its ID.
      # @param id ID of CreditCardPayment to delete.
      # @return [nil]
      def delete_by_id(id)
        delete_credit_card_payment_by_id(id)
      end

      # Create CreditCardPayment
      # Create a new CreditCardPayment
      # @param credit_card_payment Attributes of creditCardPayment to create
      # @param [Hash] opts the optional parameters
      # @return [CreditCardPayment]
      def create_credit_card_payment(credit_card_payment, opts = {})
        data, _status_code, _headers = create_credit_card_payment_with_http_info(credit_card_payment, opts)
        data
      end

      # Create CreditCardPayment
      # Create a new CreditCardPayment
      # @param credit_card_payment Attributes of creditCardPayment to create
      # @param [Hash] opts the optional parameters
      # @return [Array<(CreditCardPayment, Fixnum, Hash)>] CreditCardPayment data, response status code and response headers
      def create_credit_card_payment_with_http_info(credit_card_payment, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: CreditCardPayment.create_credit_card_payment ...'
        end
        # verify the required parameter 'credit_card_payment' is set
        if api_client.config.client_side_validation && credit_card_payment.nil?
          fail ArgumentError, "Missing the required parameter 'credit_card_payment' when calling CreditCardPayment.create_credit_card_payment"
        end
        # resource path
        local_var_path = '/creditCardPayments'

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(credit_card_payment)
        auth_names = []
        data, status_code, headers = api_client.call_api(:POST, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'CreditCardPayment')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: CreditCardPayment#create_credit_card_payment\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Delete CreditCardPayment
      # Delete an instance of CreditCardPayment by its ID.
      # @param credit_card_payment_id ID of creditCardPayment to delete.
      # @param [Hash] opts the optional parameters
      # @return [nil]
      def delete_credit_card_payment_by_id(credit_card_payment_id, opts = {})
        delete_credit_card_payment_by_id_with_http_info(credit_card_payment_id, opts)
        nil
      end

      # Delete CreditCardPayment
      # Delete an instance of CreditCardPayment by its ID.
      # @param credit_card_payment_id ID of creditCardPayment to delete.
      # @param [Hash] opts the optional parameters
      # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
      def delete_credit_card_payment_by_id_with_http_info(credit_card_payment_id, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: CreditCardPayment.delete_credit_card_payment_by_id ...'
        end
        # verify the required parameter 'credit_card_payment_id' is set
        if api_client.config.client_side_validation && credit_card_payment_id.nil?
          fail ArgumentError, "Missing the required parameter 'credit_card_payment_id' when calling CreditCardPayment.delete_credit_card_payment_by_id"
        end
        # resource path
        local_var_path = '/creditCardPayments/{creditCardPaymentId}'.sub('{' + 'creditCardPaymentId' + '}', credit_card_payment_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:DELETE, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names)
        if api_client.config.debugging
          api_client.config.logger.debug "API called: CreditCardPayment#delete_credit_card_payment_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Find CreditCardPayment
      # Return single instance of CreditCardPayment by its ID.
      # @param credit_card_payment_id ID of creditCardPayment to return
      # @param [Hash] opts the optional parameters
      # @return [CreditCardPayment]
      def get_credit_card_payment_by_id(credit_card_payment_id, opts = {})
        data, _status_code, _headers = get_credit_card_payment_by_id_with_http_info(credit_card_payment_id, opts)
        data
      end

      # Find CreditCardPayment
      # Return single instance of CreditCardPayment by its ID.
      # @param credit_card_payment_id ID of creditCardPayment to return
      # @param [Hash] opts the optional parameters
      # @return [Array<(CreditCardPayment, Fixnum, Hash)>] CreditCardPayment data, response status code and response headers
      def get_credit_card_payment_by_id_with_http_info(credit_card_payment_id, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: CreditCardPayment.get_credit_card_payment_by_id ...'
        end
        # verify the required parameter 'credit_card_payment_id' is set
        if api_client.config.client_side_validation && credit_card_payment_id.nil?
          fail ArgumentError, "Missing the required parameter 'credit_card_payment_id' when calling CreditCardPayment.get_credit_card_payment_by_id"
        end
        # resource path
        local_var_path = '/creditCardPayments/{creditCardPaymentId}'.sub('{' + 'creditCardPaymentId' + '}', credit_card_payment_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:GET, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'CreditCardPayment')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: CreditCardPayment#get_credit_card_payment_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # List CreditCardPayments
      # Return a list of CreditCardPayments
      # @param [Hash] opts the optional parameters
      # @option opts [Integer] :page page number
      # @option opts [Integer] :size page size
      # @option opts [String] :sort page order
      # @return [Page<CreditCardPayment>]
      def list_all_credit_card_payments(opts = {})
        data, _status_code, _headers = list_all_credit_card_payments_with_http_info(opts)
        data
      end

      # List CreditCardPayments
      # Return a list of CreditCardPayments
      # @param [Hash] opts the optional parameters
      # @option opts [Integer] :page page number
      # @option opts [Integer] :size page size
      # @option opts [String] :sort page order
      # @return [Array<(Page<CreditCardPayment>, Fixnum, Hash)>] Page<CreditCardPayment> data, response status code and response headers
      def list_all_credit_card_payments_with_http_info(opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: CreditCardPayment.list_all_credit_card_payments ...'
        end
        # resource path
        local_var_path = '/creditCardPayments'

        # query parameters
        query_params = opts
        # query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
        # query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?
        # query_params[:'sort'] = opts[:'sort'] if !opts[:'sort'].nil?

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:GET, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Page<CreditCardPayment>')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: CreditCardPayment#list_all_credit_card_payments\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Replace CreditCardPayment
      # Replace all attributes of CreditCardPayment
      # @param credit_card_payment_id ID of creditCardPayment to replace
      # @param credit_card_payment Attributes of creditCardPayment to replace
      # @param [Hash] opts the optional parameters
      # @return [CreditCardPayment]
      def replace_credit_card_payment_by_id(credit_card_payment_id, credit_card_payment, opts = {})
        data, _status_code, _headers = replace_credit_card_payment_by_id_with_http_info(credit_card_payment_id, credit_card_payment, opts)
        data
      end

      # Replace CreditCardPayment
      # Replace all attributes of CreditCardPayment
      # @param credit_card_payment_id ID of creditCardPayment to replace
      # @param credit_card_payment Attributes of creditCardPayment to replace
      # @param [Hash] opts the optional parameters
      # @return [Array<(CreditCardPayment, Fixnum, Hash)>] CreditCardPayment data, response status code and response headers
      def replace_credit_card_payment_by_id_with_http_info(credit_card_payment_id, credit_card_payment, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: CreditCardPayment.replace_credit_card_payment_by_id ...'
        end
        # verify the required parameter 'credit_card_payment_id' is set
        if api_client.config.client_side_validation && credit_card_payment_id.nil?
          fail ArgumentError, "Missing the required parameter 'credit_card_payment_id' when calling CreditCardPayment.replace_credit_card_payment_by_id"
        end
        # verify the required parameter 'credit_card_payment' is set
        if api_client.config.client_side_validation && credit_card_payment.nil?
          fail ArgumentError, "Missing the required parameter 'credit_card_payment' when calling CreditCardPayment.replace_credit_card_payment_by_id"
        end
        # resource path
        local_var_path = '/creditCardPayments/{creditCardPaymentId}'.sub('{' + 'creditCardPaymentId' + '}', credit_card_payment_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(credit_card_payment)
        auth_names = []
        data, status_code, headers = api_client.call_api(:PUT, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'CreditCardPayment')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: CreditCardPayment#replace_credit_card_payment_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Update CreditCardPayment
      # Update attributes of CreditCardPayment
      # @param credit_card_payment_id ID of creditCardPayment to update.
      # @param credit_card_payment Attributes of creditCardPayment to update.
      # @param [Hash] opts the optional parameters
      # @return [CreditCardPayment]
      def update_credit_card_payment_by_id(credit_card_payment_id, credit_card_payment, opts = {})
        data, _status_code, _headers = update_credit_card_payment_by_id_with_http_info(credit_card_payment_id, credit_card_payment, opts)
        data
      end

      # Update CreditCardPayment
      # Update attributes of CreditCardPayment
      # @param credit_card_payment_id ID of creditCardPayment to update.
      # @param credit_card_payment Attributes of creditCardPayment to update.
      # @param [Hash] opts the optional parameters
      # @return [Array<(CreditCardPayment, Fixnum, Hash)>] CreditCardPayment data, response status code and response headers
      def update_credit_card_payment_by_id_with_http_info(credit_card_payment_id, credit_card_payment, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: CreditCardPayment.update_credit_card_payment_by_id ...'
        end
        # verify the required parameter 'credit_card_payment_id' is set
        if api_client.config.client_side_validation && credit_card_payment_id.nil?
          fail ArgumentError, "Missing the required parameter 'credit_card_payment_id' when calling CreditCardPayment.update_credit_card_payment_by_id"
        end
        # verify the required parameter 'credit_card_payment' is set
        if api_client.config.client_side_validation && credit_card_payment.nil?
          fail ArgumentError, "Missing the required parameter 'credit_card_payment' when calling CreditCardPayment.update_credit_card_payment_by_id"
        end
        # resource path
        local_var_path = '/creditCardPayments/{creditCardPaymentId}'.sub('{' + 'creditCardPaymentId' + '}', credit_card_payment_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(credit_card_payment)
        auth_names = []
        data, status_code, headers = api_client.call_api(:PATCH, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'CreditCardPayment')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: CreditCardPayment#update_credit_card_payment_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
    end
  end
end
