=begin
#Tradenity API

#Tradenity eCommerce Rest API

Contact: support@tradenity.com
Generated by: https://github.com/tradenity

=end

require 'uri'

module Tradenity
  class Order

  
    def id=(id)
      @id = id
    end

    def id
      if instance_variable_defined?('@id') && @id != nil
        @id
      elsif __meta && __meta.href != nil
        @id = __meta.href.split('/')[-1]
        @id
      else
        nil
      end
    end

    attr_accessor :__meta

    attr_accessor :created_at

    attr_accessor :updated_at

    attr_accessor :status

    attr_accessor :subtotal

    attr_accessor :total

    attr_accessor :shipping_cost

    attr_accessor :items_tax_amount

    attr_accessor :total_items_discount

    attr_accessor :purchase_day

    attr_accessor :purchased_at

    attr_accessor :completed_at

    attr_accessor :customer

    attr_accessor :shipping_address

    attr_accessor :billing_address

    attr_accessor :currency

    attr_accessor :shipping_method

    attr_accessor :promotions

    attr_accessor :coupons

    attr_accessor :items

    attr_accessor :payments

    attr_accessor :transactions

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      { 
        :'id' => :'id',
        :'__meta' => :'__meta',
        :'created_at' => :'createdAt',
        :'updated_at' => :'updatedAt',
        :'status' => :'status',
        :'subtotal' => :'subtotal',
        :'total' => :'total',
        :'shipping_cost' => :'shippingCost',
        :'items_tax_amount' => :'itemsTaxAmount',
        :'total_items_discount' => :'totalItemsDiscount',
        :'purchase_day' => :'purchaseDay',
        :'purchased_at' => :'purchasedAt',
        :'completed_at' => :'completedAt',
        :'customer' => :'customer',
        :'shipping_address' => :'shippingAddress',
        :'billing_address' => :'billingAddress',
        :'currency' => :'currency',
        :'shipping_method' => :'shippingMethod',
        :'promotions' => :'promotions',
        :'coupons' => :'coupons',
        :'items' => :'items',
        :'payments' => :'payments',
        :'transactions' => :'transactions'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      { 
        :'id' => :'String', 
        :'__meta' => :'InstanceMeta',
        :'created_at' => :'DateTime',
        :'updated_at' => :'DateTime',
        :'status' => :'String',
        :'subtotal' => :'Integer',
        :'total' => :'Integer',
        :'shipping_cost' => :'Integer',
        :'items_tax_amount' => :'Integer',
        :'total_items_discount' => :'Integer',
        :'purchase_day' => :'Date',
        :'purchased_at' => :'DateTime',
        :'completed_at' => :'DateTime',
        :'customer' => :'Customer',
        :'shipping_address' => :'Address',
        :'billing_address' => :'Address',
        :'currency' => :'Currency',
        :'shipping_method' => :'ShippingMethod',
        :'promotions' => :'Array<Promotion>',
        :'coupons' => :'Array<Coupon>',
        :'items' => :'Array<OrderLineItem>',
        :'payments' => :'Array<Payment>',
        :'transactions' => :'Array<PaymentTransaction>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }
      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'__meta')
        self.__meta = attributes[:'__meta']
      end

      if attributes.has_key?(:'createdAt')
        self.created_at = attributes[:'createdAt']
      end

      if attributes.has_key?(:'created_at')
        self.created_at = attributes[:'created_at']
      end

      if attributes.has_key?(:'updatedAt')
        self.updated_at = attributes[:'updatedAt']
      end

      if attributes.has_key?(:'updated_at')
        self.updated_at = attributes[:'updated_at']
      end

      if attributes.has_key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.has_key?(:'subtotal')
        self.subtotal = attributes[:'subtotal']
      end

      if attributes.has_key?(:'total')
        self.total = attributes[:'total']
      end

      if attributes.has_key?(:'shippingCost')
        self.shipping_cost = attributes[:'shippingCost']
      end

      if attributes.has_key?(:'shipping_cost')
        self.shipping_cost = attributes[:'shipping_cost']
      end

      if attributes.has_key?(:'itemsTaxAmount')
        self.items_tax_amount = attributes[:'itemsTaxAmount']
      end

      if attributes.has_key?(:'items_tax_amount')
        self.items_tax_amount = attributes[:'items_tax_amount']
      end

      if attributes.has_key?(:'totalItemsDiscount')
        self.total_items_discount = attributes[:'totalItemsDiscount']
      end

      if attributes.has_key?(:'total_items_discount')
        self.total_items_discount = attributes[:'total_items_discount']
      end

      if attributes.has_key?(:'purchaseDay')
        self.purchase_day = attributes[:'purchaseDay']
      end

      if attributes.has_key?(:'purchase_day')
        self.purchase_day = attributes[:'purchase_day']
      end

      if attributes.has_key?(:'purchasedAt')
        self.purchased_at = attributes[:'purchasedAt']
      end

      if attributes.has_key?(:'purchased_at')
        self.purchased_at = attributes[:'purchased_at']
      end

      if attributes.has_key?(:'completedAt')
        self.completed_at = attributes[:'completedAt']
      end

      if attributes.has_key?(:'completed_at')
        self.completed_at = attributes[:'completed_at']
      end

      if attributes.has_key?(:'customer')
        self.customer = attributes[:'customer']
      end

      if attributes.has_key?(:'shippingAddress')
        self.shipping_address = attributes[:'shippingAddress']
      end

      if attributes.has_key?(:'shipping_address')
        self.shipping_address = attributes[:'shipping_address']
      end

      if attributes.has_key?(:'billingAddress')
        self.billing_address = attributes[:'billingAddress']
      end

      if attributes.has_key?(:'billing_address')
        self.billing_address = attributes[:'billing_address']
      end

      if attributes.has_key?(:'currency')
        self.currency = attributes[:'currency']
      end

      if attributes.has_key?(:'shippingMethod')
        self.shipping_method = attributes[:'shippingMethod']
      end

      if attributes.has_key?(:'shipping_method')
        self.shipping_method = attributes[:'shipping_method']
      end

      if attributes.has_key?(:'promotions')
        if (value = attributes[:'promotions']).is_a?(Array)
          self.promotions = value
        end
      end

      if attributes.has_key?(:'coupons')
        if (value = attributes[:'coupons']).is_a?(Array)
          self.coupons = value
        end
      end

      if attributes.has_key?(:'items')
        if (value = attributes[:'items']).is_a?(Array)
          self.items = value
        end
      end

      if attributes.has_key?(:'payments')
        if (value = attributes[:'payments']).is_a?(Array)
          self.payments = value
        end
      end

      if attributes.has_key?(:'transactions')
        if (value = attributes[:'transactions']).is_a?(Array)
          self.transactions = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @status.nil?
        invalid_properties.push('invalid value for "status", status cannot be nil.')
      end

      if @subtotal.nil?
        invalid_properties.push('invalid value for "subtotal", subtotal cannot be nil.')
      end

      if @total.nil?
        invalid_properties.push('invalid value for "total", total cannot be nil.')
      end

      if @purchase_day.nil?
        invalid_properties.push('invalid value for "purchase_day", purchase_day cannot be nil.')
      end

      if @purchased_at.nil?
        invalid_properties.push('invalid value for "purchased_at", purchased_at cannot be nil.')
      end

      if @customer.nil?
        invalid_properties.push('invalid value for "customer", customer cannot be nil.')
      end

      if @billing_address.nil?
        invalid_properties.push('invalid value for "billing_address", billing_address cannot be nil.')
      end

      if @currency.nil?
        invalid_properties.push('invalid value for "currency", currency cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @status.nil?
      status_validator = EnumAttributeValidator.new('String', ['new', 'inProgress', 'pending', 'shipping', 'completed', 'refunded'])
      return false unless status_validator.valid?(@status)
      return false if @subtotal.nil?
      return false if @total.nil?
      return false if @purchase_day.nil?
      return false if @purchased_at.nil?
      return false if @customer.nil?
      return false if @billing_address.nil?
      return false if @currency.nil?
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      validator = EnumAttributeValidator.new('String', ['new', 'inProgress', 'pending', 'shipping', 'completed', 'refunded'])
      unless validator.valid?(status)
        fail ArgumentError, 'invalid value for "status", must be one of #{validator.allowable_values}.'
      end
      @status = status
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          __meta == o.__meta &&
          created_at == o.created_at &&
          updated_at == o.updated_at &&
          status == o.status &&
          subtotal == o.subtotal &&
          total == o.total &&
          shipping_cost == o.shipping_cost &&
          items_tax_amount == o.items_tax_amount &&
          total_items_discount == o.total_items_discount &&
          purchase_day == o.purchase_day &&
          purchased_at == o.purchased_at &&
          completed_at == o.completed_at &&
          customer == o.customer &&
          shipping_address == o.shipping_address &&
          billing_address == o.billing_address &&
          currency == o.currency &&
          shipping_method == o.shipping_method &&
          promotions == o.promotions &&
          coupons == o.coupons &&
          items == o.items &&
          payments == o.payments &&
          transactions == o.transactions
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [__meta, created_at, updated_at, status, subtotal, total, shipping_cost, items_tax_amount, total_items_discount, purchase_day, purchased_at, completed_at, customer, shipping_address, billing_address, currency, shipping_method, promotions, coupons, items, payments, transactions].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Tradenity.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end


    def self.api_client
      ApiClient.default
    end

    # Create Order
    # Create a new Order
    def create
      data = self.class.create_order(self)
      self.id = data.id
      data
    end

    # Update Order
    # Update attributes of Order
    # @return [Order]
    def update
      self.class.update_order_by_id(self.id, self)
    end

    # Delete Order
    # Delete this instance of Order.
    # @return [nil]
    def delete
      self.class.delete_order_by_id(self.id)
    end

    class << self

      # List Orders
      # Return a list of Orders
      # @param [Hash] opts the optional parameters
      # @return [Page<Order>]
      def find_all
        list_all_orders
      end

      # Find List of Order
      # Return multiple instances of Order by its attributes.
      # @param [Hash] opts the search parameters
      # @return [Page<Collection>]
      def find_all_by(opts = {})
        list_all_orders(opts)
      end

      # Find Order by its parameters
      # Return single instance of Collection by its attributes.
      # @param [Hash] opts search parameters
      # @return [Order]
      def find_one_by(opts = {})
        list_all_orders(opts)[0]
      end

      # Find Order
      # Return single instance of Order by its ID.
      # @param id ID of Order to return
      # @return [Order]
      def find_by_id(id)
        get_order_by_id(id)
      end

      # Delete Order
      # Delete an instance of Order by its ID.
      # @param id ID of Order to delete.
      # @return [nil]
      def delete_by_id(id)
        delete_order_by_id(id)
      end

      # Create Order
      # Create a new Order
      # @param order Attributes of order to create
      # @param [Hash] opts the optional parameters
      # @return [Order]
      def create_order(order, opts = {})
        data, _status_code, _headers = create_order_with_http_info(order, opts)
        data
      end

      # Create Order
      # Create a new Order
      # @param order Attributes of order to create
      # @param [Hash] opts the optional parameters
      # @return [Array<(Order, Fixnum, Hash)>] Order data, response status code and response headers
      def create_order_with_http_info(order, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Order.create_order ...'
        end
        # verify the required parameter 'order' is set
        if api_client.config.client_side_validation && order.nil?
          fail ArgumentError, "Missing the required parameter 'order' when calling Order.create_order"
        end
        # resource path
        local_var_path = '/orders'

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(order)
        auth_names = []
        data, status_code, headers = api_client.call_api(:POST, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Order')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Order#create_order\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Delete Order
      # Delete an instance of Order by its ID.
      # @param order_id ID of order to delete.
      # @param [Hash] opts the optional parameters
      # @return [nil]
      def delete_order_by_id(order_id, opts = {})
        delete_order_by_id_with_http_info(order_id, opts)
        nil
      end

      # Delete Order
      # Delete an instance of Order by its ID.
      # @param order_id ID of order to delete.
      # @param [Hash] opts the optional parameters
      # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
      def delete_order_by_id_with_http_info(order_id, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Order.delete_order_by_id ...'
        end
        # verify the required parameter 'order_id' is set
        if api_client.config.client_side_validation && order_id.nil?
          fail ArgumentError, "Missing the required parameter 'order_id' when calling Order.delete_order_by_id"
        end
        # resource path
        local_var_path = '/orders/{orderId}'.sub('{' + 'orderId' + '}', order_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:DELETE, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names)
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Order#delete_order_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Find Order
      # Return single instance of Order by its ID.
      # @param order_id ID of order to return
      # @param [Hash] opts the optional parameters
      # @return [Order]
      def get_order_by_id(order_id, opts = {})
        data, _status_code, _headers = get_order_by_id_with_http_info(order_id, opts)
        data
      end

      # Find Order
      # Return single instance of Order by its ID.
      # @param order_id ID of order to return
      # @param [Hash] opts the optional parameters
      # @return [Array<(Order, Fixnum, Hash)>] Order data, response status code and response headers
      def get_order_by_id_with_http_info(order_id, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Order.get_order_by_id ...'
        end
        # verify the required parameter 'order_id' is set
        if api_client.config.client_side_validation && order_id.nil?
          fail ArgumentError, "Missing the required parameter 'order_id' when calling Order.get_order_by_id"
        end
        # resource path
        local_var_path = '/orders/{orderId}'.sub('{' + 'orderId' + '}', order_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:GET, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Order')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Order#get_order_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # List Orders
      # Return a list of Orders
      # @param [Hash] opts the optional parameters
      # @option opts [Integer] :page page number
      # @option opts [Integer] :size page size
      # @option opts [String] :sort page order
      # @return [Page<Order>]
      def list_all_orders(opts = {})
        data, _status_code, _headers = list_all_orders_with_http_info(opts)
        data
      end

      # List Orders
      # Return a list of Orders
      # @param [Hash] opts the optional parameters
      # @option opts [Integer] :page page number
      # @option opts [Integer] :size page size
      # @option opts [String] :sort page order
      # @return [Array<(Page<Order>, Fixnum, Hash)>] Page<Order> data, response status code and response headers
      def list_all_orders_with_http_info(opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Order.list_all_orders ...'
        end
        # resource path
        local_var_path = '/orders'

        # query parameters
        query_params = opts
        # query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
        # query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?
        # query_params[:'sort'] = opts[:'sort'] if !opts[:'sort'].nil?

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:GET, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Page<Order>')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Order#list_all_orders\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Replace Order
      # Replace all attributes of Order
      # @param order_id ID of order to replace
      # @param order Attributes of order to replace
      # @param [Hash] opts the optional parameters
      # @return [Order]
      def replace_order_by_id(order_id, order, opts = {})
        data, _status_code, _headers = replace_order_by_id_with_http_info(order_id, order, opts)
        data
      end

      # Replace Order
      # Replace all attributes of Order
      # @param order_id ID of order to replace
      # @param order Attributes of order to replace
      # @param [Hash] opts the optional parameters
      # @return [Array<(Order, Fixnum, Hash)>] Order data, response status code and response headers
      def replace_order_by_id_with_http_info(order_id, order, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Order.replace_order_by_id ...'
        end
        # verify the required parameter 'order_id' is set
        if api_client.config.client_side_validation && order_id.nil?
          fail ArgumentError, "Missing the required parameter 'order_id' when calling Order.replace_order_by_id"
        end
        # verify the required parameter 'order' is set
        if api_client.config.client_side_validation && order.nil?
          fail ArgumentError, "Missing the required parameter 'order' when calling Order.replace_order_by_id"
        end
        # resource path
        local_var_path = '/orders/{orderId}'.sub('{' + 'orderId' + '}', order_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(order)
        auth_names = []
        data, status_code, headers = api_client.call_api(:PUT, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Order')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Order#replace_order_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Update Order
      # Update attributes of Order
      # @param order_id ID of order to update.
      # @param order Attributes of order to update.
      # @param [Hash] opts the optional parameters
      # @return [Order]
      def update_order_by_id(order_id, order, opts = {})
        data, _status_code, _headers = update_order_by_id_with_http_info(order_id, order, opts)
        data
      end

      # Update Order
      # Update attributes of Order
      # @param order_id ID of order to update.
      # @param order Attributes of order to update.
      # @param [Hash] opts the optional parameters
      # @return [Array<(Order, Fixnum, Hash)>] Order data, response status code and response headers
      def update_order_by_id_with_http_info(order_id, order, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Order.update_order_by_id ...'
        end
        # verify the required parameter 'order_id' is set
        if api_client.config.client_side_validation && order_id.nil?
          fail ArgumentError, "Missing the required parameter 'order_id' when calling Order.update_order_by_id"
        end
        # verify the required parameter 'order' is set
        if api_client.config.client_side_validation && order.nil?
          fail ArgumentError, "Missing the required parameter 'order' when calling Order.update_order_by_id"
        end
        # resource path
        local_var_path = '/orders/{orderId}'.sub('{' + 'orderId' + '}', order_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(order)
        auth_names = []
        data, status_code, headers = api_client.call_api(:PATCH, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Order')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Order#update_order_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
    end
  end
end
