=begin
#Tradenity API

#Tradenity eCommerce Rest API

Contact: support@tradenity.com
Generated by: https://github.com/tradenity

=end

require 'uri'

module Tradenity
  class PaymentCard

  
    def id=(id)
      @id = id
    end

    def id
      if instance_variable_defined?('@id') && @id != nil
        @id
      elsif __meta && __meta.href != nil
        @id = __meta.href.split('/')[-1]
        @id
      else
        nil
      end
    end

    attr_accessor :__meta

    attr_accessor :created_at

    attr_accessor :updated_at

    attr_accessor :customer

    attr_accessor :reusable

    attr_accessor :status

    attr_accessor :card_holder_name

    attr_accessor :address

    attr_accessor :brand

    attr_accessor :expiration_month

    attr_accessor :expiration_year

    attr_accessor :ccv

    attr_accessor :card_number

    attr_accessor :card_last_four_digits

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      { 
        :'id' => :'id',
        :'__meta' => :'__meta',
        :'created_at' => :'createdAt',
        :'updated_at' => :'updatedAt',
        :'customer' => :'customer',
        :'reusable' => :'reusable',
        :'status' => :'status',
        :'card_holder_name' => :'cardHolderName',
        :'address' => :'address',
        :'brand' => :'brand',
        :'expiration_month' => :'expirationMonth',
        :'expiration_year' => :'expirationYear',
        :'ccv' => :'CCV',
        :'card_number' => :'cardNumber',
        :'card_last_four_digits' => :'cardLastFourDigits'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      { 
        :'id' => :'String', 
        :'__meta' => :'InstanceMeta',
        :'created_at' => :'DateTime',
        :'updated_at' => :'DateTime',
        :'customer' => :'Customer',
        :'reusable' => :'BOOLEAN',
        :'status' => :'String',
        :'card_holder_name' => :'String',
        :'address' => :'Address',
        :'brand' => :'String',
        :'expiration_month' => :'String',
        :'expiration_year' => :'String',
        :'ccv' => :'String',
        :'card_number' => :'String',
        :'card_last_four_digits' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }
      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'__meta')
        self.__meta = attributes[:'__meta']
      end

      if attributes.has_key?(:'createdAt')
        self.created_at = attributes[:'createdAt']
      end

      if attributes.has_key?(:'created_at')
        self.created_at = attributes[:'created_at']
      end

      if attributes.has_key?(:'updatedAt')
        self.updated_at = attributes[:'updatedAt']
      end

      if attributes.has_key?(:'updated_at')
        self.updated_at = attributes[:'updated_at']
      end

      if attributes.has_key?(:'customer')
        self.customer = attributes[:'customer']
      end

      if attributes.has_key?(:'reusable')
        self.reusable = attributes[:'reusable']
      end

      if attributes.has_key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.has_key?(:'cardHolderName')
        self.card_holder_name = attributes[:'cardHolderName']
      end

      if attributes.has_key?(:'card_holder_name')
        self.card_holder_name = attributes[:'card_holder_name']
      end

      if attributes.has_key?(:'address')
        self.address = attributes[:'address']
      end

      if attributes.has_key?(:'brand')
        self.brand = attributes[:'brand']
      end

      if attributes.has_key?(:'expirationMonth')
        self.expiration_month = attributes[:'expirationMonth']
      end

      if attributes.has_key?(:'expiration_month')
        self.expiration_month = attributes[:'expiration_month']
      end

      if attributes.has_key?(:'expirationYear')
        self.expiration_year = attributes[:'expirationYear']
      end

      if attributes.has_key?(:'expiration_year')
        self.expiration_year = attributes[:'expiration_year']
      end

      if attributes.has_key?(:'CCV')
        self.ccv = attributes[:'CCV']
      end

      if attributes.has_key?(:'ccv')
        self.ccv = attributes[:'ccv']
      end

      if attributes.has_key?(:'cardNumber')
        self.card_number = attributes[:'cardNumber']
      end

      if attributes.has_key?(:'card_number')
        self.card_number = attributes[:'card_number']
      end

      if attributes.has_key?(:'cardLastFourDigits')
        self.card_last_four_digits = attributes[:'cardLastFourDigits']
      end

      if attributes.has_key?(:'card_last_four_digits')
        self.card_last_four_digits = attributes[:'card_last_four_digits']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @customer.nil?
        invalid_properties.push('invalid value for "customer", customer cannot be nil.')
      end

      if @status.nil?
        invalid_properties.push('invalid value for "status", status cannot be nil.')
      end

      if @brand.nil?
        invalid_properties.push('invalid value for "brand", brand cannot be nil.')
      end

      if @expiration_month.nil?
        invalid_properties.push('invalid value for "expiration_month", expiration_month cannot be nil.')
      end

      if @expiration_year.nil?
        invalid_properties.push('invalid value for "expiration_year", expiration_year cannot be nil.')
      end

      if @ccv.nil?
        invalid_properties.push('invalid value for "ccv", ccv cannot be nil.')
      end

      if @card_number.nil?
        invalid_properties.push('invalid value for "card_number", card_number cannot be nil.')
      end

      if @card_last_four_digits.nil?
        invalid_properties.push('invalid value for "card_last_four_digits", card_last_four_digits cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @customer.nil?
      return false if @status.nil?
      status_validator = EnumAttributeValidator.new('String', ['new', 'used', 'expired'])
      return false unless status_validator.valid?(@status)
      return false if @brand.nil?
      brand_validator = EnumAttributeValidator.new('String', ['visa', 'mastercard', 'americanExpress', 'discover'])
      return false unless brand_validator.valid?(@brand)
      return false if @expiration_month.nil?
      return false if @expiration_year.nil?
      return false if @ccv.nil?
      return false if @card_number.nil?
      return false if @card_last_four_digits.nil?
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      validator = EnumAttributeValidator.new('String', ['new', 'used', 'expired'])
      unless validator.valid?(status)
        fail ArgumentError, 'invalid value for "status", must be one of #{validator.allowable_values}.'
      end
      @status = status
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] brand Object to be assigned
    def brand=(brand)
      validator = EnumAttributeValidator.new('String', ['visa', 'mastercard', 'americanExpress', 'discover'])
      unless validator.valid?(brand)
        fail ArgumentError, 'invalid value for "brand", must be one of #{validator.allowable_values}.'
      end
      @brand = brand
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          __meta == o.__meta &&
          created_at == o.created_at &&
          updated_at == o.updated_at &&
          customer == o.customer &&
          reusable == o.reusable &&
          status == o.status &&
          card_holder_name == o.card_holder_name &&
          address == o.address &&
          brand == o.brand &&
          expiration_month == o.expiration_month &&
          expiration_year == o.expiration_year &&
          ccv == o.ccv &&
          card_number == o.card_number &&
          card_last_four_digits == o.card_last_four_digits
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [__meta, created_at, updated_at, customer, reusable, status, card_holder_name, address, brand, expiration_month, expiration_year, ccv, card_number, card_last_four_digits].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Tradenity.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end


    def self.api_client
      ApiClient.default
    end

    # Create PaymentCard
    # Create a new PaymentCard
    def create
      data = self.class.create_payment_card(self)
      self.id = data.id
      data
    end

    # Update PaymentCard
    # Update attributes of PaymentCard
    # @return [PaymentCard]
    def update
      self.class.update_payment_card_by_id(self.id, self)
    end

    # Delete PaymentCard
    # Delete this instance of PaymentCard.
    # @return [nil]
    def delete
      self.class.delete_payment_card_by_id(self.id)
    end

    class << self

      # List PaymentCards
      # Return a list of PaymentCards
      # @param [Hash] opts the optional parameters
      # @return [Page<PaymentCard>]
      def find_all
        list_all_payment_cards
      end

      # Find List of PaymentCard
      # Return multiple instances of PaymentCard by its attributes.
      # @param [Hash] opts the search parameters
      # @return [Page<Collection>]
      def find_all_by(opts = {})
        list_all_payment_cards(opts)
      end

      # Find PaymentCard by its parameters
      # Return single instance of Collection by its attributes.
      # @param [Hash] opts search parameters
      # @return [PaymentCard]
      def find_one_by(opts = {})
        list_all_payment_cards(opts)[0]
      end

      # Find PaymentCard
      # Return single instance of PaymentCard by its ID.
      # @param id ID of PaymentCard to return
      # @return [PaymentCard]
      def find_by_id(id)
        get_payment_card_by_id(id)
      end

      # Delete PaymentCard
      # Delete an instance of PaymentCard by its ID.
      # @param id ID of PaymentCard to delete.
      # @return [nil]
      def delete_by_id(id)
        delete_payment_card_by_id(id)
      end

      # Create PaymentCard
      # Create a new PaymentCard
      # @param payment_card Attributes of paymentCard to create
      # @param [Hash] opts the optional parameters
      # @return [PaymentCard]
      def create_payment_card(payment_card, opts = {})
        data, _status_code, _headers = create_payment_card_with_http_info(payment_card, opts)
        data
      end

      # Create PaymentCard
      # Create a new PaymentCard
      # @param payment_card Attributes of paymentCard to create
      # @param [Hash] opts the optional parameters
      # @return [Array<(PaymentCard, Fixnum, Hash)>] PaymentCard data, response status code and response headers
      def create_payment_card_with_http_info(payment_card, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: PaymentCard.create_payment_card ...'
        end
        # verify the required parameter 'payment_card' is set
        if api_client.config.client_side_validation && payment_card.nil?
          fail ArgumentError, "Missing the required parameter 'payment_card' when calling PaymentCard.create_payment_card"
        end
        # resource path
        local_var_path = '/paymentCards'

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(payment_card)
        auth_names = []
        data, status_code, headers = api_client.call_api(:POST, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'PaymentCard')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: PaymentCard#create_payment_card\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Delete PaymentCard
      # Delete an instance of PaymentCard by its ID.
      # @param payment_card_id ID of paymentCard to delete.
      # @param [Hash] opts the optional parameters
      # @return [nil]
      def delete_payment_card_by_id(payment_card_id, opts = {})
        delete_payment_card_by_id_with_http_info(payment_card_id, opts)
        nil
      end

      # Delete PaymentCard
      # Delete an instance of PaymentCard by its ID.
      # @param payment_card_id ID of paymentCard to delete.
      # @param [Hash] opts the optional parameters
      # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
      def delete_payment_card_by_id_with_http_info(payment_card_id, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: PaymentCard.delete_payment_card_by_id ...'
        end
        # verify the required parameter 'payment_card_id' is set
        if api_client.config.client_side_validation && payment_card_id.nil?
          fail ArgumentError, "Missing the required parameter 'payment_card_id' when calling PaymentCard.delete_payment_card_by_id"
        end
        # resource path
        local_var_path = '/paymentCards/{paymentCardId}'.sub('{' + 'paymentCardId' + '}', payment_card_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:DELETE, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names)
        if api_client.config.debugging
          api_client.config.logger.debug "API called: PaymentCard#delete_payment_card_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Find PaymentCard
      # Return single instance of PaymentCard by its ID.
      # @param payment_card_id ID of paymentCard to return
      # @param [Hash] opts the optional parameters
      # @return [PaymentCard]
      def get_payment_card_by_id(payment_card_id, opts = {})
        data, _status_code, _headers = get_payment_card_by_id_with_http_info(payment_card_id, opts)
        data
      end

      # Find PaymentCard
      # Return single instance of PaymentCard by its ID.
      # @param payment_card_id ID of paymentCard to return
      # @param [Hash] opts the optional parameters
      # @return [Array<(PaymentCard, Fixnum, Hash)>] PaymentCard data, response status code and response headers
      def get_payment_card_by_id_with_http_info(payment_card_id, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: PaymentCard.get_payment_card_by_id ...'
        end
        # verify the required parameter 'payment_card_id' is set
        if api_client.config.client_side_validation && payment_card_id.nil?
          fail ArgumentError, "Missing the required parameter 'payment_card_id' when calling PaymentCard.get_payment_card_by_id"
        end
        # resource path
        local_var_path = '/paymentCards/{paymentCardId}'.sub('{' + 'paymentCardId' + '}', payment_card_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:GET, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'PaymentCard')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: PaymentCard#get_payment_card_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # List PaymentCards
      # Return a list of PaymentCards
      # @param [Hash] opts the optional parameters
      # @option opts [Integer] :page page number
      # @option opts [Integer] :size page size
      # @option opts [String] :sort page order
      # @return [Page<PaymentCard>]
      def list_all_payment_cards(opts = {})
        data, _status_code, _headers = list_all_payment_cards_with_http_info(opts)
        data
      end

      # List PaymentCards
      # Return a list of PaymentCards
      # @param [Hash] opts the optional parameters
      # @option opts [Integer] :page page number
      # @option opts [Integer] :size page size
      # @option opts [String] :sort page order
      # @return [Array<(Page<PaymentCard>, Fixnum, Hash)>] Page<PaymentCard> data, response status code and response headers
      def list_all_payment_cards_with_http_info(opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: PaymentCard.list_all_payment_cards ...'
        end
        # resource path
        local_var_path = '/paymentCards'

        # query parameters
        query_params = opts
        # query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
        # query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?
        # query_params[:'sort'] = opts[:'sort'] if !opts[:'sort'].nil?

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:GET, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Page<PaymentCard>')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: PaymentCard#list_all_payment_cards\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Replace PaymentCard
      # Replace all attributes of PaymentCard
      # @param payment_card_id ID of paymentCard to replace
      # @param payment_card Attributes of paymentCard to replace
      # @param [Hash] opts the optional parameters
      # @return [PaymentCard]
      def replace_payment_card_by_id(payment_card_id, payment_card, opts = {})
        data, _status_code, _headers = replace_payment_card_by_id_with_http_info(payment_card_id, payment_card, opts)
        data
      end

      # Replace PaymentCard
      # Replace all attributes of PaymentCard
      # @param payment_card_id ID of paymentCard to replace
      # @param payment_card Attributes of paymentCard to replace
      # @param [Hash] opts the optional parameters
      # @return [Array<(PaymentCard, Fixnum, Hash)>] PaymentCard data, response status code and response headers
      def replace_payment_card_by_id_with_http_info(payment_card_id, payment_card, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: PaymentCard.replace_payment_card_by_id ...'
        end
        # verify the required parameter 'payment_card_id' is set
        if api_client.config.client_side_validation && payment_card_id.nil?
          fail ArgumentError, "Missing the required parameter 'payment_card_id' when calling PaymentCard.replace_payment_card_by_id"
        end
        # verify the required parameter 'payment_card' is set
        if api_client.config.client_side_validation && payment_card.nil?
          fail ArgumentError, "Missing the required parameter 'payment_card' when calling PaymentCard.replace_payment_card_by_id"
        end
        # resource path
        local_var_path = '/paymentCards/{paymentCardId}'.sub('{' + 'paymentCardId' + '}', payment_card_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(payment_card)
        auth_names = []
        data, status_code, headers = api_client.call_api(:PUT, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'PaymentCard')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: PaymentCard#replace_payment_card_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Update PaymentCard
      # Update attributes of PaymentCard
      # @param payment_card_id ID of paymentCard to update.
      # @param payment_card Attributes of paymentCard to update.
      # @param [Hash] opts the optional parameters
      # @return [PaymentCard]
      def update_payment_card_by_id(payment_card_id, payment_card, opts = {})
        data, _status_code, _headers = update_payment_card_by_id_with_http_info(payment_card_id, payment_card, opts)
        data
      end

      # Update PaymentCard
      # Update attributes of PaymentCard
      # @param payment_card_id ID of paymentCard to update.
      # @param payment_card Attributes of paymentCard to update.
      # @param [Hash] opts the optional parameters
      # @return [Array<(PaymentCard, Fixnum, Hash)>] PaymentCard data, response status code and response headers
      def update_payment_card_by_id_with_http_info(payment_card_id, payment_card, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: PaymentCard.update_payment_card_by_id ...'
        end
        # verify the required parameter 'payment_card_id' is set
        if api_client.config.client_side_validation && payment_card_id.nil?
          fail ArgumentError, "Missing the required parameter 'payment_card_id' when calling PaymentCard.update_payment_card_by_id"
        end
        # verify the required parameter 'payment_card' is set
        if api_client.config.client_side_validation && payment_card.nil?
          fail ArgumentError, "Missing the required parameter 'payment_card' when calling PaymentCard.update_payment_card_by_id"
        end
        # resource path
        local_var_path = '/paymentCards/{paymentCardId}'.sub('{' + 'paymentCardId' + '}', payment_card_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(payment_card)
        auth_names = []
        data, status_code, headers = api_client.call_api(:PATCH, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'PaymentCard')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: PaymentCard#update_payment_card_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
    end
  end
end
