=begin
#Tradenity API

#Tradenity eCommerce Rest API

Contact: support@tradenity.com
Generated by: https://github.com/tradenity

=end

require 'uri'

module Tradenity
  class StoreProfile

  
    def id=(id)
      @id = id
    end

    def id
      if instance_variable_defined?('@id') && @id != nil
        @id
      elsif __meta && __meta.href != nil
        @id = __meta.href.split('/')[-1]
        @id
      else
        nil
      end
    end

    attr_accessor :__meta

    attr_accessor :created_at

    attr_accessor :updated_at

    attr_accessor :name

    attr_accessor :description

    attr_accessor :contact_info

    attr_accessor :billing_info

    attr_accessor :facebook

    attr_accessor :twitter

    attr_accessor :youtube

    attr_accessor :instagram

    attr_accessor :pinterest

    attr_accessor :linkedin

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      { 
        :'id' => :'id',
        :'__meta' => :'__meta',
        :'created_at' => :'createdAt',
        :'updated_at' => :'updatedAt',
        :'name' => :'name',
        :'description' => :'description',
        :'contact_info' => :'contactInfo',
        :'billing_info' => :'billingInfo',
        :'facebook' => :'facebook',
        :'twitter' => :'twitter',
        :'youtube' => :'youtube',
        :'instagram' => :'instagram',
        :'pinterest' => :'pinterest',
        :'linkedin' => :'linkedin'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      { 
        :'id' => :'String', 
        :'__meta' => :'InstanceMeta',
        :'created_at' => :'DateTime',
        :'updated_at' => :'DateTime',
        :'name' => :'String',
        :'description' => :'String',
        :'contact_info' => :'ContactInfo',
        :'billing_info' => :'ContactInfo',
        :'facebook' => :'String',
        :'twitter' => :'String',
        :'youtube' => :'String',
        :'instagram' => :'String',
        :'pinterest' => :'String',
        :'linkedin' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }
      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'__meta')
        self.__meta = attributes[:'__meta']
      end

      if attributes.has_key?(:'createdAt')
        self.created_at = attributes[:'createdAt']
      end

      if attributes.has_key?(:'created_at')
        self.created_at = attributes[:'created_at']
      end

      if attributes.has_key?(:'updatedAt')
        self.updated_at = attributes[:'updatedAt']
      end

      if attributes.has_key?(:'updated_at')
        self.updated_at = attributes[:'updated_at']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.has_key?(:'contactInfo')
        self.contact_info = attributes[:'contactInfo']
      end

      if attributes.has_key?(:'contact_info')
        self.contact_info = attributes[:'contact_info']
      end

      if attributes.has_key?(:'billingInfo')
        self.billing_info = attributes[:'billingInfo']
      end

      if attributes.has_key?(:'billing_info')
        self.billing_info = attributes[:'billing_info']
      end

      if attributes.has_key?(:'facebook')
        self.facebook = attributes[:'facebook']
      end

      if attributes.has_key?(:'twitter')
        self.twitter = attributes[:'twitter']
      end

      if attributes.has_key?(:'youtube')
        self.youtube = attributes[:'youtube']
      end

      if attributes.has_key?(:'instagram')
        self.instagram = attributes[:'instagram']
      end

      if attributes.has_key?(:'pinterest')
        self.pinterest = attributes[:'pinterest']
      end

      if attributes.has_key?(:'linkedin')
        self.linkedin = attributes[:'linkedin']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @name.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          __meta == o.__meta &&
          created_at == o.created_at &&
          updated_at == o.updated_at &&
          name == o.name &&
          description == o.description &&
          contact_info == o.contact_info &&
          billing_info == o.billing_info &&
          facebook == o.facebook &&
          twitter == o.twitter &&
          youtube == o.youtube &&
          instagram == o.instagram &&
          pinterest == o.pinterest &&
          linkedin == o.linkedin
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [__meta, created_at, updated_at, name, description, contact_info, billing_info, facebook, twitter, youtube, instagram, pinterest, linkedin].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Tradenity.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end


    def self.api_client
      ApiClient.default
    end

    # Update StoreProfile
    # Update attributes of StoreProfile
    # @return [StoreProfile]
    def update
      self.class.update_store_profile_by_id(self.id, self)
    end


    class << self

      # Find StoreProfile
      # Return single instance of StoreProfile by its ID.
      # @param id ID of StoreProfile to return
      # @return [StoreProfile]
      def find_by_id(id)
        get_store_profile_by_id(id)
      end


      # Find StoreProfile
      # Return single instance of StoreProfile by its ID.
      # @param store_profile_id ID of storeProfile to return
      # @param [Hash] opts the optional parameters
      # @return [StoreProfile]
      def get_store_profile_by_id(store_profile_id, opts = {})
        data, _status_code, _headers = get_store_profile_by_id_with_http_info(store_profile_id, opts)
        data
      end

      # Find StoreProfile
      # Return single instance of StoreProfile by its ID.
      # @param store_profile_id ID of storeProfile to return
      # @param [Hash] opts the optional parameters
      # @return [Array<(StoreProfile, Fixnum, Hash)>] StoreProfile data, response status code and response headers
      def get_store_profile_by_id_with_http_info(store_profile_id, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: StoreProfile.get_store_profile_by_id ...'
        end
        # verify the required parameter 'store_profile_id' is set
        if api_client.config.client_side_validation && store_profile_id.nil?
          fail ArgumentError, "Missing the required parameter 'store_profile_id' when calling StoreProfile.get_store_profile_by_id"
        end
        # resource path
        local_var_path = '/storeProfiles/{storeProfileId}'.sub('{' + 'storeProfileId' + '}', store_profile_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:GET, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'StoreProfile')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: StoreProfile#get_store_profile_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Replace StoreProfile
      # Replace all attributes of StoreProfile
      # @param store_profile_id ID of storeProfile to replace
      # @param store_profile Attributes of storeProfile to replace
      # @param [Hash] opts the optional parameters
      # @return [StoreProfile]
      def replace_store_profile_by_id(store_profile_id, store_profile, opts = {})
        data, _status_code, _headers = replace_store_profile_by_id_with_http_info(store_profile_id, store_profile, opts)
        data
      end

      # Replace StoreProfile
      # Replace all attributes of StoreProfile
      # @param store_profile_id ID of storeProfile to replace
      # @param store_profile Attributes of storeProfile to replace
      # @param [Hash] opts the optional parameters
      # @return [Array<(StoreProfile, Fixnum, Hash)>] StoreProfile data, response status code and response headers
      def replace_store_profile_by_id_with_http_info(store_profile_id, store_profile, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: StoreProfile.replace_store_profile_by_id ...'
        end
        # verify the required parameter 'store_profile_id' is set
        if api_client.config.client_side_validation && store_profile_id.nil?
          fail ArgumentError, "Missing the required parameter 'store_profile_id' when calling StoreProfile.replace_store_profile_by_id"
        end
        # verify the required parameter 'store_profile' is set
        if api_client.config.client_side_validation && store_profile.nil?
          fail ArgumentError, "Missing the required parameter 'store_profile' when calling StoreProfile.replace_store_profile_by_id"
        end
        # resource path
        local_var_path = '/storeProfiles/{storeProfileId}'.sub('{' + 'storeProfileId' + '}', store_profile_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(store_profile)
        auth_names = []
        data, status_code, headers = api_client.call_api(:PUT, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'StoreProfile')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: StoreProfile#replace_store_profile_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Update StoreProfile
      # Update attributes of StoreProfile
      # @param store_profile_id ID of storeProfile to update.
      # @param store_profile Attributes of storeProfile to update.
      # @param [Hash] opts the optional parameters
      # @return [StoreProfile]
      def update_store_profile_by_id(store_profile_id, store_profile, opts = {})
        data, _status_code, _headers = update_store_profile_by_id_with_http_info(store_profile_id, store_profile, opts)
        data
      end

      # Update StoreProfile
      # Update attributes of StoreProfile
      # @param store_profile_id ID of storeProfile to update.
      # @param store_profile Attributes of storeProfile to update.
      # @param [Hash] opts the optional parameters
      # @return [Array<(StoreProfile, Fixnum, Hash)>] StoreProfile data, response status code and response headers
      def update_store_profile_by_id_with_http_info(store_profile_id, store_profile, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: StoreProfile.update_store_profile_by_id ...'
        end
        # verify the required parameter 'store_profile_id' is set
        if api_client.config.client_side_validation && store_profile_id.nil?
          fail ArgumentError, "Missing the required parameter 'store_profile_id' when calling StoreProfile.update_store_profile_by_id"
        end
        # verify the required parameter 'store_profile' is set
        if api_client.config.client_side_validation && store_profile.nil?
          fail ArgumentError, "Missing the required parameter 'store_profile' when calling StoreProfile.update_store_profile_by_id"
        end
        # resource path
        local_var_path = '/storeProfiles/{storeProfileId}'.sub('{' + 'storeProfileId' + '}', store_profile_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(store_profile)
        auth_names = []
        data, status_code, headers = api_client.call_api(:PATCH, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'StoreProfile')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: StoreProfile#update_store_profile_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
    end
  end
end
