=begin
#Tradenity API

#Tradenity eCommerce Rest API

Contact: support@tradenity.com
Generated by: https://github.com/tradenity

=end

require 'uri'

module Tradenity
  class StripeGateway

  
    def id=(id)
      @id = id
    end

    def id
      if instance_variable_defined?('@id') && @id != nil
        @id
      elsif __meta && __meta.href != nil
        @id = __meta.href.split('/')[-1]
        @id
      else
        nil
      end
    end

    attr_accessor :__meta

    attr_accessor :created_at

    attr_accessor :updated_at

    attr_accessor :name

    attr_accessor :mode

    attr_accessor :authorize_only

    attr_accessor :account_id

    attr_accessor :status

    attr_accessor :secret_key

    attr_accessor :public_key

    attr_accessor :test_secret_key

    attr_accessor :test_public_key

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      { 
        :'id' => :'id',
        :'__meta' => :'__meta',
        :'created_at' => :'createdAt',
        :'updated_at' => :'updatedAt',
        :'name' => :'name',
        :'mode' => :'mode',
        :'authorize_only' => :'authorizeOnly',
        :'account_id' => :'accountId',
        :'status' => :'status',
        :'secret_key' => :'secretKey',
        :'public_key' => :'publicKey',
        :'test_secret_key' => :'testSecretKey',
        :'test_public_key' => :'testPublicKey'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      { 
        :'id' => :'String', 
        :'__meta' => :'InstanceMeta',
        :'created_at' => :'DateTime',
        :'updated_at' => :'DateTime',
        :'name' => :'String',
        :'mode' => :'String',
        :'authorize_only' => :'BOOLEAN',
        :'account_id' => :'String',
        :'status' => :'String',
        :'secret_key' => :'String',
        :'public_key' => :'String',
        :'test_secret_key' => :'String',
        :'test_public_key' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }
      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'__meta')
        self.__meta = attributes[:'__meta']
      end

      if attributes.has_key?(:'createdAt')
        self.created_at = attributes[:'createdAt']
      end

      if attributes.has_key?(:'created_at')
        self.created_at = attributes[:'created_at']
      end

      if attributes.has_key?(:'updatedAt')
        self.updated_at = attributes[:'updatedAt']
      end

      if attributes.has_key?(:'updated_at')
        self.updated_at = attributes[:'updated_at']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'mode')
        self.mode = attributes[:'mode']
      end

      if attributes.has_key?(:'authorizeOnly')
        self.authorize_only = attributes[:'authorizeOnly']
      end

      if attributes.has_key?(:'authorize_only')
        self.authorize_only = attributes[:'authorize_only']
      end

      if attributes.has_key?(:'accountId')
        self.account_id = attributes[:'accountId']
      end

      if attributes.has_key?(:'account_id')
        self.account_id = attributes[:'account_id']
      end

      if attributes.has_key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.has_key?(:'secretKey')
        self.secret_key = attributes[:'secretKey']
      end

      if attributes.has_key?(:'secret_key')
        self.secret_key = attributes[:'secret_key']
      end

      if attributes.has_key?(:'publicKey')
        self.public_key = attributes[:'publicKey']
      end

      if attributes.has_key?(:'public_key')
        self.public_key = attributes[:'public_key']
      end

      if attributes.has_key?(:'testSecretKey')
        self.test_secret_key = attributes[:'testSecretKey']
      end

      if attributes.has_key?(:'test_secret_key')
        self.test_secret_key = attributes[:'test_secret_key']
      end

      if attributes.has_key?(:'testPublicKey')
        self.test_public_key = attributes[:'testPublicKey']
      end

      if attributes.has_key?(:'test_public_key')
        self.test_public_key = attributes[:'test_public_key']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @mode.nil?
        invalid_properties.push('invalid value for "mode", mode cannot be nil.')
      end

      if @status.nil?
        invalid_properties.push('invalid value for "status", status cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @name.nil?
      return false if @mode.nil?
      mode_validator = EnumAttributeValidator.new('String', ['test', 'live'])
      return false unless mode_validator.valid?(@mode)
      return false if @status.nil?
      status_validator = EnumAttributeValidator.new('String', ['enabled', 'disabled'])
      return false unless status_validator.valid?(@status)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] mode Object to be assigned
    def mode=(mode)
      validator = EnumAttributeValidator.new('String', ['test', 'live'])
      unless validator.valid?(mode)
        fail ArgumentError, 'invalid value for "mode", must be one of #{validator.allowable_values}.'
      end
      @mode = mode
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      validator = EnumAttributeValidator.new('String', ['enabled', 'disabled'])
      unless validator.valid?(status)
        fail ArgumentError, 'invalid value for "status", must be one of #{validator.allowable_values}.'
      end
      @status = status
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          __meta == o.__meta &&
          created_at == o.created_at &&
          updated_at == o.updated_at &&
          name == o.name &&
          mode == o.mode &&
          authorize_only == o.authorize_only &&
          account_id == o.account_id &&
          status == o.status &&
          secret_key == o.secret_key &&
          public_key == o.public_key &&
          test_secret_key == o.test_secret_key &&
          test_public_key == o.test_public_key
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [__meta, created_at, updated_at, name, mode, authorize_only, account_id, status, secret_key, public_key, test_secret_key, test_public_key].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Tradenity.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end


    def self.api_client
      ApiClient.default
    end

    # Create StripeGateway
    # Create a new StripeGateway
    def create
      data = self.class.create_stripe_gateway(self)
      self.id = data.id
      data
    end

    # Update StripeGateway
    # Update attributes of StripeGateway
    # @return [StripeGateway]
    def update
      self.class.update_stripe_gateway_by_id(self.id, self)
    end

    # Delete StripeGateway
    # Delete this instance of StripeGateway.
    # @return [nil]
    def delete
      self.class.delete_stripe_gateway_by_id(self.id)
    end

    class << self

      # List StripeGateways
      # Return a list of StripeGateways
      # @param [Hash] opts the optional parameters
      # @return [Page<StripeGateway>]
      def find_all
        list_all_stripe_gateways
      end

      # Find List of StripeGateway
      # Return multiple instances of StripeGateway by its attributes.
      # @param [Hash] opts the search parameters
      # @return [Page<Collection>]
      def find_all_by(opts = {})
        list_all_stripe_gateways(opts)
      end

      # Find StripeGateway by its parameters
      # Return single instance of Collection by its attributes.
      # @param [Hash] opts search parameters
      # @return [StripeGateway]
      def find_one_by(opts = {})
        list_all_stripe_gateways(opts)[0]
      end

      # Find StripeGateway
      # Return single instance of StripeGateway by its ID.
      # @param id ID of StripeGateway to return
      # @return [StripeGateway]
      def find_by_id(id)
        get_stripe_gateway_by_id(id)
      end

      # Delete StripeGateway
      # Delete an instance of StripeGateway by its ID.
      # @param id ID of StripeGateway to delete.
      # @return [nil]
      def delete_by_id(id)
        delete_stripe_gateway_by_id(id)
      end

      # Create StripeGateway
      # Create a new StripeGateway
      # @param stripe_gateway Attributes of stripeGateway to create
      # @param [Hash] opts the optional parameters
      # @return [StripeGateway]
      def create_stripe_gateway(stripe_gateway, opts = {})
        data, _status_code, _headers = create_stripe_gateway_with_http_info(stripe_gateway, opts)
        data
      end

      # Create StripeGateway
      # Create a new StripeGateway
      # @param stripe_gateway Attributes of stripeGateway to create
      # @param [Hash] opts the optional parameters
      # @return [Array<(StripeGateway, Fixnum, Hash)>] StripeGateway data, response status code and response headers
      def create_stripe_gateway_with_http_info(stripe_gateway, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: StripeGateway.create_stripe_gateway ...'
        end
        # verify the required parameter 'stripe_gateway' is set
        if api_client.config.client_side_validation && stripe_gateway.nil?
          fail ArgumentError, "Missing the required parameter 'stripe_gateway' when calling StripeGateway.create_stripe_gateway"
        end
        # resource path
        local_var_path = '/stripeGateways'

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(stripe_gateway)
        auth_names = []
        data, status_code, headers = api_client.call_api(:POST, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'StripeGateway')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: StripeGateway#create_stripe_gateway\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Delete StripeGateway
      # Delete an instance of StripeGateway by its ID.
      # @param stripe_gateway_id ID of stripeGateway to delete.
      # @param [Hash] opts the optional parameters
      # @return [nil]
      def delete_stripe_gateway_by_id(stripe_gateway_id, opts = {})
        delete_stripe_gateway_by_id_with_http_info(stripe_gateway_id, opts)
        nil
      end

      # Delete StripeGateway
      # Delete an instance of StripeGateway by its ID.
      # @param stripe_gateway_id ID of stripeGateway to delete.
      # @param [Hash] opts the optional parameters
      # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
      def delete_stripe_gateway_by_id_with_http_info(stripe_gateway_id, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: StripeGateway.delete_stripe_gateway_by_id ...'
        end
        # verify the required parameter 'stripe_gateway_id' is set
        if api_client.config.client_side_validation && stripe_gateway_id.nil?
          fail ArgumentError, "Missing the required parameter 'stripe_gateway_id' when calling StripeGateway.delete_stripe_gateway_by_id"
        end
        # resource path
        local_var_path = '/stripeGateways/{stripeGatewayId}'.sub('{' + 'stripeGatewayId' + '}', stripe_gateway_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:DELETE, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names)
        if api_client.config.debugging
          api_client.config.logger.debug "API called: StripeGateway#delete_stripe_gateway_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Find StripeGateway
      # Return single instance of StripeGateway by its ID.
      # @param stripe_gateway_id ID of stripeGateway to return
      # @param [Hash] opts the optional parameters
      # @return [StripeGateway]
      def get_stripe_gateway_by_id(stripe_gateway_id, opts = {})
        data, _status_code, _headers = get_stripe_gateway_by_id_with_http_info(stripe_gateway_id, opts)
        data
      end

      # Find StripeGateway
      # Return single instance of StripeGateway by its ID.
      # @param stripe_gateway_id ID of stripeGateway to return
      # @param [Hash] opts the optional parameters
      # @return [Array<(StripeGateway, Fixnum, Hash)>] StripeGateway data, response status code and response headers
      def get_stripe_gateway_by_id_with_http_info(stripe_gateway_id, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: StripeGateway.get_stripe_gateway_by_id ...'
        end
        # verify the required parameter 'stripe_gateway_id' is set
        if api_client.config.client_side_validation && stripe_gateway_id.nil?
          fail ArgumentError, "Missing the required parameter 'stripe_gateway_id' when calling StripeGateway.get_stripe_gateway_by_id"
        end
        # resource path
        local_var_path = '/stripeGateways/{stripeGatewayId}'.sub('{' + 'stripeGatewayId' + '}', stripe_gateway_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:GET, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'StripeGateway')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: StripeGateway#get_stripe_gateway_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # List StripeGateways
      # Return a list of StripeGateways
      # @param [Hash] opts the optional parameters
      # @option opts [Integer] :page page number
      # @option opts [Integer] :size page size
      # @option opts [String] :sort page order
      # @return [Page<StripeGateway>]
      def list_all_stripe_gateways(opts = {})
        data, _status_code, _headers = list_all_stripe_gateways_with_http_info(opts)
        data
      end

      # List StripeGateways
      # Return a list of StripeGateways
      # @param [Hash] opts the optional parameters
      # @option opts [Integer] :page page number
      # @option opts [Integer] :size page size
      # @option opts [String] :sort page order
      # @return [Array<(Page<StripeGateway>, Fixnum, Hash)>] Page<StripeGateway> data, response status code and response headers
      def list_all_stripe_gateways_with_http_info(opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: StripeGateway.list_all_stripe_gateways ...'
        end
        # resource path
        local_var_path = '/stripeGateways'

        # query parameters
        query_params = opts
        # query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
        # query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?
        # query_params[:'sort'] = opts[:'sort'] if !opts[:'sort'].nil?

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:GET, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Page<StripeGateway>')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: StripeGateway#list_all_stripe_gateways\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Replace StripeGateway
      # Replace all attributes of StripeGateway
      # @param stripe_gateway_id ID of stripeGateway to replace
      # @param stripe_gateway Attributes of stripeGateway to replace
      # @param [Hash] opts the optional parameters
      # @return [StripeGateway]
      def replace_stripe_gateway_by_id(stripe_gateway_id, stripe_gateway, opts = {})
        data, _status_code, _headers = replace_stripe_gateway_by_id_with_http_info(stripe_gateway_id, stripe_gateway, opts)
        data
      end

      # Replace StripeGateway
      # Replace all attributes of StripeGateway
      # @param stripe_gateway_id ID of stripeGateway to replace
      # @param stripe_gateway Attributes of stripeGateway to replace
      # @param [Hash] opts the optional parameters
      # @return [Array<(StripeGateway, Fixnum, Hash)>] StripeGateway data, response status code and response headers
      def replace_stripe_gateway_by_id_with_http_info(stripe_gateway_id, stripe_gateway, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: StripeGateway.replace_stripe_gateway_by_id ...'
        end
        # verify the required parameter 'stripe_gateway_id' is set
        if api_client.config.client_side_validation && stripe_gateway_id.nil?
          fail ArgumentError, "Missing the required parameter 'stripe_gateway_id' when calling StripeGateway.replace_stripe_gateway_by_id"
        end
        # verify the required parameter 'stripe_gateway' is set
        if api_client.config.client_side_validation && stripe_gateway.nil?
          fail ArgumentError, "Missing the required parameter 'stripe_gateway' when calling StripeGateway.replace_stripe_gateway_by_id"
        end
        # resource path
        local_var_path = '/stripeGateways/{stripeGatewayId}'.sub('{' + 'stripeGatewayId' + '}', stripe_gateway_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(stripe_gateway)
        auth_names = []
        data, status_code, headers = api_client.call_api(:PUT, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'StripeGateway')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: StripeGateway#replace_stripe_gateway_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Update StripeGateway
      # Update attributes of StripeGateway
      # @param stripe_gateway_id ID of stripeGateway to update.
      # @param stripe_gateway Attributes of stripeGateway to update.
      # @param [Hash] opts the optional parameters
      # @return [StripeGateway]
      def update_stripe_gateway_by_id(stripe_gateway_id, stripe_gateway, opts = {})
        data, _status_code, _headers = update_stripe_gateway_by_id_with_http_info(stripe_gateway_id, stripe_gateway, opts)
        data
      end

      # Update StripeGateway
      # Update attributes of StripeGateway
      # @param stripe_gateway_id ID of stripeGateway to update.
      # @param stripe_gateway Attributes of stripeGateway to update.
      # @param [Hash] opts the optional parameters
      # @return [Array<(StripeGateway, Fixnum, Hash)>] StripeGateway data, response status code and response headers
      def update_stripe_gateway_by_id_with_http_info(stripe_gateway_id, stripe_gateway, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: StripeGateway.update_stripe_gateway_by_id ...'
        end
        # verify the required parameter 'stripe_gateway_id' is set
        if api_client.config.client_side_validation && stripe_gateway_id.nil?
          fail ArgumentError, "Missing the required parameter 'stripe_gateway_id' when calling StripeGateway.update_stripe_gateway_by_id"
        end
        # verify the required parameter 'stripe_gateway' is set
        if api_client.config.client_side_validation && stripe_gateway.nil?
          fail ArgumentError, "Missing the required parameter 'stripe_gateway' when calling StripeGateway.update_stripe_gateway_by_id"
        end
        # resource path
        local_var_path = '/stripeGateways/{stripeGatewayId}'.sub('{' + 'stripeGatewayId' + '}', stripe_gateway_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(stripe_gateway)
        auth_names = []
        data, status_code, headers = api_client.call_api(:PATCH, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'StripeGateway')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: StripeGateway#update_stripe_gateway_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
    end
  end
end
