=begin
#Tradenity API

#Tradenity eCommerce Rest API

Contact: support@tradenity.com
Generated by: https://github.com/tradenity

=end

require 'uri'

module Tradenity
  class TaxRate

  
    def id=(id)
      @id = id
    end

    def id
      if instance_variable_defined?('@id') && @id != nil
        @id
      elsif __meta && __meta.href != nil
        @id = __meta.href.split('/')[-1]
        @id
      else
        nil
      end
    end

    attr_accessor :__meta

    attr_accessor :created_at

    attr_accessor :updated_at

    attr_accessor :name

    attr_accessor :description

    attr_accessor :type

    attr_accessor :percentage

    attr_accessor :fixed_rate

    attr_accessor :status

    attr_accessor :tax_class

    attr_accessor :geo_zone

    attr_accessor :customer_groups

    attr_accessor :based_on

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      { 
        :'id' => :'id',
        :'__meta' => :'__meta',
        :'created_at' => :'createdAt',
        :'updated_at' => :'updatedAt',
        :'name' => :'name',
        :'description' => :'description',
        :'type' => :'type',
        :'percentage' => :'percentage',
        :'fixed_rate' => :'fixedRate',
        :'status' => :'status',
        :'tax_class' => :'taxClass',
        :'geo_zone' => :'geoZone',
        :'customer_groups' => :'customerGroups',
        :'based_on' => :'basedOn'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      { 
        :'id' => :'String', 
        :'__meta' => :'InstanceMeta',
        :'created_at' => :'DateTime',
        :'updated_at' => :'DateTime',
        :'name' => :'String',
        :'description' => :'String',
        :'type' => :'String',
        :'percentage' => :'Float',
        :'fixed_rate' => :'Integer',
        :'status' => :'String',
        :'tax_class' => :'TaxClass',
        :'geo_zone' => :'GeoZone',
        :'customer_groups' => :'Array<CustomerGroup>',
        :'based_on' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }
      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'__meta')
        self.__meta = attributes[:'__meta']
      end

      if attributes.has_key?(:'createdAt')
        self.created_at = attributes[:'createdAt']
      end

      if attributes.has_key?(:'created_at')
        self.created_at = attributes[:'created_at']
      end

      if attributes.has_key?(:'updatedAt')
        self.updated_at = attributes[:'updatedAt']
      end

      if attributes.has_key?(:'updated_at')
        self.updated_at = attributes[:'updated_at']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.has_key?(:'type')
        self.type = attributes[:'type']
      end

      if attributes.has_key?(:'percentage')
        self.percentage = attributes[:'percentage']
      end

      if attributes.has_key?(:'fixedRate')
        self.fixed_rate = attributes[:'fixedRate']
      end

      if attributes.has_key?(:'fixed_rate')
        self.fixed_rate = attributes[:'fixed_rate']
      end

      if attributes.has_key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.has_key?(:'taxClass')
        self.tax_class = attributes[:'taxClass']
      end

      if attributes.has_key?(:'tax_class')
        self.tax_class = attributes[:'tax_class']
      end

      if attributes.has_key?(:'geoZone')
        self.geo_zone = attributes[:'geoZone']
      end

      if attributes.has_key?(:'geo_zone')
        self.geo_zone = attributes[:'geo_zone']
      end

      if attributes.has_key?(:'customerGroups')
        if (value = attributes[:'customerGroups']).is_a?(Array)
          self.customer_groups = value
        end
      end

      if attributes.has_key?(:'customer_groups')
        if (value = attributes[:'customer_groups']).is_a?(Array)
          self.customer_groups = value
        end
      end

      if attributes.has_key?(:'basedOn')
        self.based_on = attributes[:'basedOn']
      end

      if attributes.has_key?(:'based_on')
        self.based_on = attributes[:'based_on']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @type.nil?
        invalid_properties.push('invalid value for "type", type cannot be nil.')
      end

      if @percentage.nil?
        invalid_properties.push('invalid value for "percentage", percentage cannot be nil.')
      end

      if @fixed_rate.nil?
        invalid_properties.push('invalid value for "fixed_rate", fixed_rate cannot be nil.')
      end

      if @status.nil?
        invalid_properties.push('invalid value for "status", status cannot be nil.')
      end

      if @tax_class.nil?
        invalid_properties.push('invalid value for "tax_class", tax_class cannot be nil.')
      end

      if @geo_zone.nil?
        invalid_properties.push('invalid value for "geo_zone", geo_zone cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @name.nil?
      return false if @type.nil?
      type_validator = EnumAttributeValidator.new('String', ['percentage', 'fixed'])
      return false unless type_validator.valid?(@type)
      return false if @percentage.nil?
      return false if @fixed_rate.nil?
      return false if @status.nil?
      status_validator = EnumAttributeValidator.new('String', ['enabled', 'disabled'])
      return false unless status_validator.valid?(@status)
      return false if @tax_class.nil?
      return false if @geo_zone.nil?
      based_on_validator = EnumAttributeValidator.new('String', ['shippingAddress', 'billingAddress'])
      return false unless based_on_validator.valid?(@based_on)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] type Object to be assigned
    def type=(type)
      validator = EnumAttributeValidator.new('String', ['percentage', 'fixed'])
      unless validator.valid?(type)
        fail ArgumentError, 'invalid value for "type", must be one of #{validator.allowable_values}.'
      end
      @type = type
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      validator = EnumAttributeValidator.new('String', ['enabled', 'disabled'])
      unless validator.valid?(status)
        fail ArgumentError, 'invalid value for "status", must be one of #{validator.allowable_values}.'
      end
      @status = status
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] based_on Object to be assigned
    def based_on=(based_on)
      validator = EnumAttributeValidator.new('String', ['shippingAddress', 'billingAddress'])
      unless validator.valid?(based_on)
        fail ArgumentError, 'invalid value for "based_on", must be one of #{validator.allowable_values}.'
      end
      @based_on = based_on
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          __meta == o.__meta &&
          created_at == o.created_at &&
          updated_at == o.updated_at &&
          name == o.name &&
          description == o.description &&
          type == o.type &&
          percentage == o.percentage &&
          fixed_rate == o.fixed_rate &&
          status == o.status &&
          tax_class == o.tax_class &&
          geo_zone == o.geo_zone &&
          customer_groups == o.customer_groups &&
          based_on == o.based_on
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [__meta, created_at, updated_at, name, description, type, percentage, fixed_rate, status, tax_class, geo_zone, customer_groups, based_on].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Tradenity.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end


    def self.api_client
      ApiClient.default
    end

    # Create TaxRate
    # Create a new TaxRate
    def create
      data = self.class.create_tax_rate(self)
      self.id = data.id
      data
    end

    # Update TaxRate
    # Update attributes of TaxRate
    # @return [TaxRate]
    def update
      self.class.update_tax_rate_by_id(self.id, self)
    end

    # Delete TaxRate
    # Delete this instance of TaxRate.
    # @return [nil]
    def delete
      self.class.delete_tax_rate_by_id(self.id)
    end

    class << self

      # List TaxRates
      # Return a list of TaxRates
      # @param [Hash] opts the optional parameters
      # @return [Page<TaxRate>]
      def find_all
        list_all_tax_rates
      end

      # Find List of TaxRate
      # Return multiple instances of TaxRate by its attributes.
      # @param [Hash] opts the search parameters
      # @return [Page<Collection>]
      def find_all_by(opts = {})
        list_all_tax_rates(opts)
      end

      # Find TaxRate by its parameters
      # Return single instance of Collection by its attributes.
      # @param [Hash] opts search parameters
      # @return [TaxRate]
      def find_one_by(opts = {})
        list_all_tax_rates(opts)[0]
      end

      # Find TaxRate
      # Return single instance of TaxRate by its ID.
      # @param id ID of TaxRate to return
      # @return [TaxRate]
      def find_by_id(id)
        get_tax_rate_by_id(id)
      end

      # Delete TaxRate
      # Delete an instance of TaxRate by its ID.
      # @param id ID of TaxRate to delete.
      # @return [nil]
      def delete_by_id(id)
        delete_tax_rate_by_id(id)
      end

      # Create TaxRate
      # Create a new TaxRate
      # @param tax_rate Attributes of taxRate to create
      # @param [Hash] opts the optional parameters
      # @return [TaxRate]
      def create_tax_rate(tax_rate, opts = {})
        data, _status_code, _headers = create_tax_rate_with_http_info(tax_rate, opts)
        data
      end

      # Create TaxRate
      # Create a new TaxRate
      # @param tax_rate Attributes of taxRate to create
      # @param [Hash] opts the optional parameters
      # @return [Array<(TaxRate, Fixnum, Hash)>] TaxRate data, response status code and response headers
      def create_tax_rate_with_http_info(tax_rate, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: TaxRate.create_tax_rate ...'
        end
        # verify the required parameter 'tax_rate' is set
        if api_client.config.client_side_validation && tax_rate.nil?
          fail ArgumentError, "Missing the required parameter 'tax_rate' when calling TaxRate.create_tax_rate"
        end
        # resource path
        local_var_path = '/taxRates'

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(tax_rate)
        auth_names = []
        data, status_code, headers = api_client.call_api(:POST, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'TaxRate')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: TaxRate#create_tax_rate\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Delete TaxRate
      # Delete an instance of TaxRate by its ID.
      # @param tax_rate_id ID of taxRate to delete.
      # @param [Hash] opts the optional parameters
      # @return [nil]
      def delete_tax_rate_by_id(tax_rate_id, opts = {})
        delete_tax_rate_by_id_with_http_info(tax_rate_id, opts)
        nil
      end

      # Delete TaxRate
      # Delete an instance of TaxRate by its ID.
      # @param tax_rate_id ID of taxRate to delete.
      # @param [Hash] opts the optional parameters
      # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
      def delete_tax_rate_by_id_with_http_info(tax_rate_id, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: TaxRate.delete_tax_rate_by_id ...'
        end
        # verify the required parameter 'tax_rate_id' is set
        if api_client.config.client_side_validation && tax_rate_id.nil?
          fail ArgumentError, "Missing the required parameter 'tax_rate_id' when calling TaxRate.delete_tax_rate_by_id"
        end
        # resource path
        local_var_path = '/taxRates/{taxRateId}'.sub('{' + 'taxRateId' + '}', tax_rate_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:DELETE, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names)
        if api_client.config.debugging
          api_client.config.logger.debug "API called: TaxRate#delete_tax_rate_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Find TaxRate
      # Return single instance of TaxRate by its ID.
      # @param tax_rate_id ID of taxRate to return
      # @param [Hash] opts the optional parameters
      # @return [TaxRate]
      def get_tax_rate_by_id(tax_rate_id, opts = {})
        data, _status_code, _headers = get_tax_rate_by_id_with_http_info(tax_rate_id, opts)
        data
      end

      # Find TaxRate
      # Return single instance of TaxRate by its ID.
      # @param tax_rate_id ID of taxRate to return
      # @param [Hash] opts the optional parameters
      # @return [Array<(TaxRate, Fixnum, Hash)>] TaxRate data, response status code and response headers
      def get_tax_rate_by_id_with_http_info(tax_rate_id, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: TaxRate.get_tax_rate_by_id ...'
        end
        # verify the required parameter 'tax_rate_id' is set
        if api_client.config.client_side_validation && tax_rate_id.nil?
          fail ArgumentError, "Missing the required parameter 'tax_rate_id' when calling TaxRate.get_tax_rate_by_id"
        end
        # resource path
        local_var_path = '/taxRates/{taxRateId}'.sub('{' + 'taxRateId' + '}', tax_rate_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:GET, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'TaxRate')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: TaxRate#get_tax_rate_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # List TaxRates
      # Return a list of TaxRates
      # @param [Hash] opts the optional parameters
      # @option opts [Integer] :page page number
      # @option opts [Integer] :size page size
      # @option opts [String] :sort page order
      # @return [Page<TaxRate>]
      def list_all_tax_rates(opts = {})
        data, _status_code, _headers = list_all_tax_rates_with_http_info(opts)
        data
      end

      # List TaxRates
      # Return a list of TaxRates
      # @param [Hash] opts the optional parameters
      # @option opts [Integer] :page page number
      # @option opts [Integer] :size page size
      # @option opts [String] :sort page order
      # @return [Array<(Page<TaxRate>, Fixnum, Hash)>] Page<TaxRate> data, response status code and response headers
      def list_all_tax_rates_with_http_info(opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: TaxRate.list_all_tax_rates ...'
        end
        # resource path
        local_var_path = '/taxRates'

        # query parameters
        query_params = opts
        # query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
        # query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?
        # query_params[:'sort'] = opts[:'sort'] if !opts[:'sort'].nil?

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:GET, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Page<TaxRate>')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: TaxRate#list_all_tax_rates\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Replace TaxRate
      # Replace all attributes of TaxRate
      # @param tax_rate_id ID of taxRate to replace
      # @param tax_rate Attributes of taxRate to replace
      # @param [Hash] opts the optional parameters
      # @return [TaxRate]
      def replace_tax_rate_by_id(tax_rate_id, tax_rate, opts = {})
        data, _status_code, _headers = replace_tax_rate_by_id_with_http_info(tax_rate_id, tax_rate, opts)
        data
      end

      # Replace TaxRate
      # Replace all attributes of TaxRate
      # @param tax_rate_id ID of taxRate to replace
      # @param tax_rate Attributes of taxRate to replace
      # @param [Hash] opts the optional parameters
      # @return [Array<(TaxRate, Fixnum, Hash)>] TaxRate data, response status code and response headers
      def replace_tax_rate_by_id_with_http_info(tax_rate_id, tax_rate, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: TaxRate.replace_tax_rate_by_id ...'
        end
        # verify the required parameter 'tax_rate_id' is set
        if api_client.config.client_side_validation && tax_rate_id.nil?
          fail ArgumentError, "Missing the required parameter 'tax_rate_id' when calling TaxRate.replace_tax_rate_by_id"
        end
        # verify the required parameter 'tax_rate' is set
        if api_client.config.client_side_validation && tax_rate.nil?
          fail ArgumentError, "Missing the required parameter 'tax_rate' when calling TaxRate.replace_tax_rate_by_id"
        end
        # resource path
        local_var_path = '/taxRates/{taxRateId}'.sub('{' + 'taxRateId' + '}', tax_rate_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(tax_rate)
        auth_names = []
        data, status_code, headers = api_client.call_api(:PUT, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'TaxRate')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: TaxRate#replace_tax_rate_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Update TaxRate
      # Update attributes of TaxRate
      # @param tax_rate_id ID of taxRate to update.
      # @param tax_rate Attributes of taxRate to update.
      # @param [Hash] opts the optional parameters
      # @return [TaxRate]
      def update_tax_rate_by_id(tax_rate_id, tax_rate, opts = {})
        data, _status_code, _headers = update_tax_rate_by_id_with_http_info(tax_rate_id, tax_rate, opts)
        data
      end

      # Update TaxRate
      # Update attributes of TaxRate
      # @param tax_rate_id ID of taxRate to update.
      # @param tax_rate Attributes of taxRate to update.
      # @param [Hash] opts the optional parameters
      # @return [Array<(TaxRate, Fixnum, Hash)>] TaxRate data, response status code and response headers
      def update_tax_rate_by_id_with_http_info(tax_rate_id, tax_rate, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: TaxRate.update_tax_rate_by_id ...'
        end
        # verify the required parameter 'tax_rate_id' is set
        if api_client.config.client_side_validation && tax_rate_id.nil?
          fail ArgumentError, "Missing the required parameter 'tax_rate_id' when calling TaxRate.update_tax_rate_by_id"
        end
        # verify the required parameter 'tax_rate' is set
        if api_client.config.client_side_validation && tax_rate.nil?
          fail ArgumentError, "Missing the required parameter 'tax_rate' when calling TaxRate.update_tax_rate_by_id"
        end
        # resource path
        local_var_path = '/taxRates/{taxRateId}'.sub('{' + 'taxRateId' + '}', tax_rate_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(tax_rate)
        auth_names = []
        data, status_code, headers = api_client.call_api(:PATCH, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'TaxRate')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: TaxRate#update_tax_rate_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
    end
  end
end
