=begin
#Tradenity API

#Tradenity eCommerce Rest API

Contact: support@tradenity.com
Generated by: https://github.com/tradenity

=end

require 'uri'

module Tradenity
  class Variant

  
    def id=(id)
      @id = id
    end

    def id
      if instance_variable_defined?('@id') && @id != nil
        @id
      elsif __meta && __meta.href != nil
        @id = __meta.href.split('/')[-1]
        @id
      else
        nil
      end
    end

    attr_accessor :__meta

    attr_accessor :created_at

    attr_accessor :updated_at

    attr_accessor :name

    attr_accessor :slug

    attr_accessor :sku

    attr_accessor :description

    attr_accessor :status

    attr_accessor :price_change

    attr_accessor :stock_level

    attr_accessor :minimum_stock_level

    attr_accessor :maximum_sell_count

    attr_accessor :item_dimensions

    attr_accessor :package_dimensions

    attr_accessor :package_weight

    attr_accessor :product

    attr_accessor :option_set

    attr_accessor :option_values

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      { 
        :'id' => :'id',
        :'__meta' => :'__meta',
        :'created_at' => :'createdAt',
        :'updated_at' => :'updatedAt',
        :'name' => :'name',
        :'slug' => :'slug',
        :'sku' => :'sku',
        :'description' => :'description',
        :'status' => :'status',
        :'price_change' => :'priceChange',
        :'stock_level' => :'stockLevel',
        :'minimum_stock_level' => :'minimumStockLevel',
        :'maximum_sell_count' => :'maximumSellCount',
        :'item_dimensions' => :'itemDimensions',
        :'package_dimensions' => :'packageDimensions',
        :'package_weight' => :'packageWeight',
        :'product' => :'product',
        :'option_set' => :'optionSet',
        :'option_values' => :'optionValues'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      { 
        :'id' => :'String', 
        :'__meta' => :'InstanceMeta',
        :'created_at' => :'DateTime',
        :'updated_at' => :'DateTime',
        :'name' => :'String',
        :'slug' => :'String',
        :'sku' => :'String',
        :'description' => :'String',
        :'status' => :'String',
        :'price_change' => :'Integer',
        :'stock_level' => :'Integer',
        :'minimum_stock_level' => :'Integer',
        :'maximum_sell_count' => :'Integer',
        :'item_dimensions' => :'Dimensions',
        :'package_dimensions' => :'Dimensions',
        :'package_weight' => :'Weight',
        :'product' => :'Product',
        :'option_set' => :'OptionSet',
        :'option_values' => :'Array<OptionValue>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }
      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'__meta')
        self.__meta = attributes[:'__meta']
      end

      if attributes.has_key?(:'createdAt')
        self.created_at = attributes[:'createdAt']
      end

      if attributes.has_key?(:'created_at')
        self.created_at = attributes[:'created_at']
      end

      if attributes.has_key?(:'updatedAt')
        self.updated_at = attributes[:'updatedAt']
      end

      if attributes.has_key?(:'updated_at')
        self.updated_at = attributes[:'updated_at']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'slug')
        self.slug = attributes[:'slug']
      end

      if attributes.has_key?(:'sku')
        self.sku = attributes[:'sku']
      end

      if attributes.has_key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.has_key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.has_key?(:'priceChange')
        self.price_change = attributes[:'priceChange']
      end

      if attributes.has_key?(:'price_change')
        self.price_change = attributes[:'price_change']
      end

      if attributes.has_key?(:'stockLevel')
        self.stock_level = attributes[:'stockLevel']
      end

      if attributes.has_key?(:'stock_level')
        self.stock_level = attributes[:'stock_level']
      end

      if attributes.has_key?(:'minimumStockLevel')
        self.minimum_stock_level = attributes[:'minimumStockLevel']
      end

      if attributes.has_key?(:'minimum_stock_level')
        self.minimum_stock_level = attributes[:'minimum_stock_level']
      end

      if attributes.has_key?(:'maximumSellCount')
        self.maximum_sell_count = attributes[:'maximumSellCount']
      end

      if attributes.has_key?(:'maximum_sell_count')
        self.maximum_sell_count = attributes[:'maximum_sell_count']
      end

      if attributes.has_key?(:'itemDimensions')
        self.item_dimensions = attributes[:'itemDimensions']
      end

      if attributes.has_key?(:'item_dimensions')
        self.item_dimensions = attributes[:'item_dimensions']
      end

      if attributes.has_key?(:'packageDimensions')
        self.package_dimensions = attributes[:'packageDimensions']
      end

      if attributes.has_key?(:'package_dimensions')
        self.package_dimensions = attributes[:'package_dimensions']
      end

      if attributes.has_key?(:'packageWeight')
        self.package_weight = attributes[:'packageWeight']
      end

      if attributes.has_key?(:'package_weight')
        self.package_weight = attributes[:'package_weight']
      end

      if attributes.has_key?(:'product')
        self.product = attributes[:'product']
      end

      if attributes.has_key?(:'optionSet')
        self.option_set = attributes[:'optionSet']
      end

      if attributes.has_key?(:'option_set')
        self.option_set = attributes[:'option_set']
      end

      if attributes.has_key?(:'optionValues')
        if (value = attributes[:'optionValues']).is_a?(Array)
          self.option_values = value
        end
      end

      if attributes.has_key?(:'option_values')
        if (value = attributes[:'option_values']).is_a?(Array)
          self.option_values = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @slug.nil?
        invalid_properties.push('invalid value for "slug", slug cannot be nil.')
      end

      if @sku.nil?
        invalid_properties.push('invalid value for "sku", sku cannot be nil.')
      end

      if @status.nil?
        invalid_properties.push('invalid value for "status", status cannot be nil.')
      end

      if @product.nil?
        invalid_properties.push('invalid value for "product", product cannot be nil.')
      end

      if @option_set.nil?
        invalid_properties.push('invalid value for "option_set", option_set cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @name.nil?
      return false if @slug.nil?
      return false if @sku.nil?
      return false if @status.nil?
      status_validator = EnumAttributeValidator.new('String', ['enabled', 'disabled'])
      return false unless status_validator.valid?(@status)
      return false if @product.nil?
      return false if @option_set.nil?
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      validator = EnumAttributeValidator.new('String', ['enabled', 'disabled'])
      unless validator.valid?(status)
        fail ArgumentError, 'invalid value for "status", must be one of #{validator.allowable_values}.'
      end
      @status = status
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          __meta == o.__meta &&
          created_at == o.created_at &&
          updated_at == o.updated_at &&
          name == o.name &&
          slug == o.slug &&
          sku == o.sku &&
          description == o.description &&
          status == o.status &&
          price_change == o.price_change &&
          stock_level == o.stock_level &&
          minimum_stock_level == o.minimum_stock_level &&
          maximum_sell_count == o.maximum_sell_count &&
          item_dimensions == o.item_dimensions &&
          package_dimensions == o.package_dimensions &&
          package_weight == o.package_weight &&
          product == o.product &&
          option_set == o.option_set &&
          option_values == o.option_values
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [__meta, created_at, updated_at, name, slug, sku, description, status, price_change, stock_level, minimum_stock_level, maximum_sell_count, item_dimensions, package_dimensions, package_weight, product, option_set, option_values].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Tradenity.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end


    def self.api_client
      ApiClient.default
    end

    # Create Variant
    # Create a new Variant
    def create
      data = self.class.create_variant(self)
      self.id = data.id
      data
    end

    # Update Variant
    # Update attributes of Variant
    # @return [Variant]
    def update
      self.class.update_variant_by_id(self.id, self)
    end

    # Delete Variant
    # Delete this instance of Variant.
    # @return [nil]
    def delete
      self.class.delete_variant_by_id(self.id)
    end

    class << self

      # List Variants
      # Return a list of Variants
      # @param [Hash] opts the optional parameters
      # @return [Page<Variant>]
      def find_all
        list_all_variants
      end

      # Find List of Variant
      # Return multiple instances of Variant by its attributes.
      # @param [Hash] opts the search parameters
      # @return [Page<Collection>]
      def find_all_by(opts = {})
        list_all_variants(opts)
      end

      # Find Variant by its parameters
      # Return single instance of Collection by its attributes.
      # @param [Hash] opts search parameters
      # @return [Variant]
      def find_one_by(opts = {})
        list_all_variants(opts)[0]
      end

      # Find Variant
      # Return single instance of Variant by its ID.
      # @param id ID of Variant to return
      # @return [Variant]
      def find_by_id(id)
        get_variant_by_id(id)
      end

      # Delete Variant
      # Delete an instance of Variant by its ID.
      # @param id ID of Variant to delete.
      # @return [nil]
      def delete_by_id(id)
        delete_variant_by_id(id)
      end

      # Create Variant
      # Create a new Variant
      # @param variant Attributes of variant to create
      # @param [Hash] opts the optional parameters
      # @return [Variant]
      def create_variant(variant, opts = {})
        data, _status_code, _headers = create_variant_with_http_info(variant, opts)
        data
      end

      # Create Variant
      # Create a new Variant
      # @param variant Attributes of variant to create
      # @param [Hash] opts the optional parameters
      # @return [Array<(Variant, Fixnum, Hash)>] Variant data, response status code and response headers
      def create_variant_with_http_info(variant, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Variant.create_variant ...'
        end
        # verify the required parameter 'variant' is set
        if api_client.config.client_side_validation && variant.nil?
          fail ArgumentError, "Missing the required parameter 'variant' when calling Variant.create_variant"
        end
        # resource path
        local_var_path = '/variants'

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(variant)
        auth_names = []
        data, status_code, headers = api_client.call_api(:POST, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Variant')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Variant#create_variant\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Delete Variant
      # Delete an instance of Variant by its ID.
      # @param variant_id ID of variant to delete.
      # @param [Hash] opts the optional parameters
      # @return [nil]
      def delete_variant_by_id(variant_id, opts = {})
        delete_variant_by_id_with_http_info(variant_id, opts)
        nil
      end

      # Delete Variant
      # Delete an instance of Variant by its ID.
      # @param variant_id ID of variant to delete.
      # @param [Hash] opts the optional parameters
      # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
      def delete_variant_by_id_with_http_info(variant_id, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Variant.delete_variant_by_id ...'
        end
        # verify the required parameter 'variant_id' is set
        if api_client.config.client_side_validation && variant_id.nil?
          fail ArgumentError, "Missing the required parameter 'variant_id' when calling Variant.delete_variant_by_id"
        end
        # resource path
        local_var_path = '/variants/{variantId}'.sub('{' + 'variantId' + '}', variant_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:DELETE, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names)
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Variant#delete_variant_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Find Variant
      # Return single instance of Variant by its ID.
      # @param variant_id ID of variant to return
      # @param [Hash] opts the optional parameters
      # @return [Variant]
      def get_variant_by_id(variant_id, opts = {})
        data, _status_code, _headers = get_variant_by_id_with_http_info(variant_id, opts)
        data
      end

      # Find Variant
      # Return single instance of Variant by its ID.
      # @param variant_id ID of variant to return
      # @param [Hash] opts the optional parameters
      # @return [Array<(Variant, Fixnum, Hash)>] Variant data, response status code and response headers
      def get_variant_by_id_with_http_info(variant_id, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Variant.get_variant_by_id ...'
        end
        # verify the required parameter 'variant_id' is set
        if api_client.config.client_side_validation && variant_id.nil?
          fail ArgumentError, "Missing the required parameter 'variant_id' when calling Variant.get_variant_by_id"
        end
        # resource path
        local_var_path = '/variants/{variantId}'.sub('{' + 'variantId' + '}', variant_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:GET, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Variant')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Variant#get_variant_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # List Variants
      # Return a list of Variants
      # @param [Hash] opts the optional parameters
      # @option opts [Integer] :page page number
      # @option opts [Integer] :size page size
      # @option opts [String] :sort page order
      # @return [Page<Variant>]
      def list_all_variants(opts = {})
        data, _status_code, _headers = list_all_variants_with_http_info(opts)
        data
      end

      # List Variants
      # Return a list of Variants
      # @param [Hash] opts the optional parameters
      # @option opts [Integer] :page page number
      # @option opts [Integer] :size page size
      # @option opts [String] :sort page order
      # @return [Array<(Page<Variant>, Fixnum, Hash)>] Page<Variant> data, response status code and response headers
      def list_all_variants_with_http_info(opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Variant.list_all_variants ...'
        end
        # resource path
        local_var_path = '/variants'

        # query parameters
        query_params = opts
        # query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
        # query_params[:'size'] = opts[:'size'] if !opts[:'size'].nil?
        # query_params[:'sort'] = opts[:'sort'] if !opts[:'sort'].nil?

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = nil
        auth_names = []
        data, status_code, headers = api_client.call_api(:GET, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Page<Variant>')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Variant#list_all_variants\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Replace Variant
      # Replace all attributes of Variant
      # @param variant_id ID of variant to replace
      # @param variant Attributes of variant to replace
      # @param [Hash] opts the optional parameters
      # @return [Variant]
      def replace_variant_by_id(variant_id, variant, opts = {})
        data, _status_code, _headers = replace_variant_by_id_with_http_info(variant_id, variant, opts)
        data
      end

      # Replace Variant
      # Replace all attributes of Variant
      # @param variant_id ID of variant to replace
      # @param variant Attributes of variant to replace
      # @param [Hash] opts the optional parameters
      # @return [Array<(Variant, Fixnum, Hash)>] Variant data, response status code and response headers
      def replace_variant_by_id_with_http_info(variant_id, variant, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Variant.replace_variant_by_id ...'
        end
        # verify the required parameter 'variant_id' is set
        if api_client.config.client_side_validation && variant_id.nil?
          fail ArgumentError, "Missing the required parameter 'variant_id' when calling Variant.replace_variant_by_id"
        end
        # verify the required parameter 'variant' is set
        if api_client.config.client_side_validation && variant.nil?
          fail ArgumentError, "Missing the required parameter 'variant' when calling Variant.replace_variant_by_id"
        end
        # resource path
        local_var_path = '/variants/{variantId}'.sub('{' + 'variantId' + '}', variant_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(variant)
        auth_names = []
        data, status_code, headers = api_client.call_api(:PUT, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Variant')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Variant#replace_variant_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
      # Update Variant
      # Update attributes of Variant
      # @param variant_id ID of variant to update.
      # @param variant Attributes of variant to update.
      # @param [Hash] opts the optional parameters
      # @return [Variant]
      def update_variant_by_id(variant_id, variant, opts = {})
        data, _status_code, _headers = update_variant_by_id_with_http_info(variant_id, variant, opts)
        data
      end

      # Update Variant
      # Update attributes of Variant
      # @param variant_id ID of variant to update.
      # @param variant Attributes of variant to update.
      # @param [Hash] opts the optional parameters
      # @return [Array<(Variant, Fixnum, Hash)>] Variant data, response status code and response headers
      def update_variant_by_id_with_http_info(variant_id, variant, opts = {})
        if api_client.config.debugging
          api_client.config.logger.debug 'Calling API: Variant.update_variant_by_id ...'
        end
        # verify the required parameter 'variant_id' is set
        if api_client.config.client_side_validation && variant_id.nil?
          fail ArgumentError, "Missing the required parameter 'variant_id' when calling Variant.update_variant_by_id"
        end
        # verify the required parameter 'variant' is set
        if api_client.config.client_side_validation && variant.nil?
          fail ArgumentError, "Missing the required parameter 'variant' when calling Variant.update_variant_by_id"
        end
        # resource path
        local_var_path = '/variants/{variantId}'.sub('{' + 'variantId' + '}', variant_id.to_s)

        # query parameters
        query_params = opts

        # header parameters
        header_params = {}
        # HTTP header 'Accept' (if needed)
        header_params['Accept'] = api_client.select_header_accept(['application/json'])
        # HTTP header 'Content-Type'
        header_params['Content-Type'] = api_client.select_header_content_type(['application/json'])

        # form parameters
        form_params = {}

        # http body (model)
        post_body = api_client.object_to_http_body(variant)
        auth_names = []
        data, status_code, headers = api_client.call_api(:PATCH, local_var_path,
          :header_params => header_params,
          :query_params => query_params,
          :form_params => form_params,
          :body => post_body,
          :auth_names => auth_names,
          :return_type => 'Variant')
        if api_client.config.debugging
          api_client.config.logger.debug "API called: Variant#update_variant_by_id\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
        end
        return data, status_code, headers
      end
    end
  end
end
